 #if !defined(MQC_INCLUDED)            /* File not yet included?      */
   #define MQC_INCLUDED                /* Show file now included      */
 /*********************************************************************/
 /*                                                                   */
 /*                  IBM MQSeries for Linux/Intel                     */
 /*                                                                   */
 /*  HEADER NAME:    CMQC                                             */
 /*                                                                   */
 /*  DESCRIPTION:    Declarations for Main MQI                        */
 /*                                                                   */
 /*********************************************************************/
 /*  @START_COPYRIGHT@                                                */
 /*  Licensed Materials - Property of IBM                             */
 /*                                                                   */
 /*                                                                   */
 /*  (C) Copyright IBM Corporation 1993, 2001.                        */
 /*                                                                   */
 /*  Status: Version 5 Release 2                                      */
 /*  @END_COPYRIGHT@                                                  */
 /*********************************************************************/
 /*                                                                   */
 /*  FUNCTION:       This file declares the functions, structures,    */
 /*                  and named constants for the main MQI.            */
 /*                                                                   */
 /*  PROCESSOR:      C                                                */
 /*                                                                   */
 /*********************************************************************/

 #if defined(__cplusplus)
   extern "C" {
 #endif


 /*********************************************************************/
 /*  Values Related to MQBO Structure                                 */
 /*********************************************************************/

 /* Structure Identifier */
 #define MQBO_STRUC_ID "BO  "

 /* Structure Identifier (array form) */
 #define MQBO_STRUC_ID_ARRAY 'B','O',' ',' '

 /* Structure Version Number */
 #define MQBO_VERSION_1       1L
 #define MQBO_CURRENT_VERSION 1L

 /* Begin Options */
 #define MQBO_NONE 0L



 /*********************************************************************/
 /*  Values Related to MQCIH Structure                                */
 /*********************************************************************/

 /* Structure Identifier */
 #define MQCIH_STRUC_ID "CIH "

 /* Structure Identifier (array form) */
 #define MQCIH_STRUC_ID_ARRAY 'C','I','H',' '

 /* Structure Version Number */
 #define MQCIH_VERSION_1       1L
 #define MQCIH_VERSION_2       2L
 #define MQCIH_CURRENT_VERSION 2L

 /* Structure Length */
 #define MQCIH_LENGTH_1       164L
 #define MQCIH_LENGTH_2       180L
 #define MQCIH_CURRENT_LENGTH 180L

 /* Flags */
 #define MQCIH_NONE 0L

 /* Return Code */
 #define MQCRC_OK                    0L
 #define MQCRC_CICS_EXEC_ERROR       1L
 #define MQCRC_MQ_API_ERROR          2L
 #define MQCRC_BRIDGE_ERROR          3L
 #define MQCRC_BRIDGE_ABEND          4L
 #define MQCRC_APPLICATION_ABEND     5L
 #define MQCRC_SECURITY_ERROR        6L
 #define MQCRC_PROGRAM_NOT_AVAILABLE 7L
 #define MQCRC_BRIDGE_TIMEOUT        8L
 #define MQCRC_TRANSID_NOT_AVAILABLE 9L

 /* Unit of Work Control */
 #define MQCUOWC_ONLY     0x00000111L
 #define MQCUOWC_CONTINUE 0x00010000L
 #define MQCUOWC_FIRST    0x00000011L
 #define MQCUOWC_MIDDLE   0x00000010L
 #define MQCUOWC_LAST     0x00000110L
 #define MQCUOWC_COMMIT   0x00000100L
 #define MQCUOWC_BACKOUT  0x00001100L

 /* Get Wait Interval */
 #define MQCGWI_DEFAULT (-2L)

 /* Link Type */
 #define MQCLT_PROGRAM     1L
 #define MQCLT_TRANSACTION 2L

 /* Output Data Length */
 #define MQCODL_AS_INPUT (-1L)

 /* ADS Descriptor */
 #define MQCADSD_NONE      0x00000000L
 #define MQCADSD_SEND      0x00000001L
 #define MQCADSD_RECV      0x00000010L
 #define MQCADSD_MSGFORMAT 0x00000100L

 /* Conversational Task */
 #define MQCCT_YES 0x00000001L
 #define MQCCT_NO  0x00000000L

 /* Task End Status */
 #define MQCTES_NOSYNC  0x00000000L
 #define MQCTES_COMMIT  0x00000100L
 #define MQCTES_BACKOUT 0x00001100L
 #define MQCTES_ENDTASK 0x00010000L

 /* Facility */
 #define MQCFAC_NONE "\0\0\0\0\0\0\0\0"

 /* Facility (array form) */
 #define MQCFAC_NONE_ARRAY '\0','\0','\0','\0','\0','\0','\0','\0'

 /* Function */
 #define MQCFUNC_MQCONN "CONN"
 #define MQCFUNC_MQGET  "GET "
 #define MQCFUNC_MQINQ  "INQ "
 #define MQCFUNC_MQOPEN "OPEN"
 #define MQCFUNC_MQPUT  "PUT "
 #define MQCFUNC_MQPUT1 "PUT1"
 #define MQCFUNC_NONE   "    "

 /* Function (array form) */
 #define MQCFUNC_MQCONN_ARRAY 'C','O','N','N'
 #define MQCFUNC_MQGET_ARRAY  'G','E','T',' '
 #define MQCFUNC_MQINQ_ARRAY  'I','N','Q',' '
 #define MQCFUNC_MQOPEN_ARRAY 'O','P','E','N'
 #define MQCFUNC_MQPUT_ARRAY  'P','U','T',' '
 #define MQCFUNC_MQPUT1_ARRAY 'P','U','T','1'
 #define MQCFUNC_NONE_ARRAY   ' ',' ',' ',' '

 /* Start Code */
 #define MQCSC_START     "S   "
 #define MQCSC_STARTDATA "SD  "
 #define MQCSC_TERMINPUT "TD  "
 #define MQCSC_NONE      "    "

 /* Start Code (array form) */
 #define MQCSC_START_ARRAY     'S',' ',' ',' '
 #define MQCSC_STARTDATA_ARRAY 'S','D',' ',' '
 #define MQCSC_TERMINPUT_ARRAY 'T','D',' ',' '
 #define MQCSC_NONE_ARRAY      ' ',' ',' ',' '

 /*********************************************************************/
 /*  Values Related to MQCNO Structure                                */
 /*********************************************************************/

 /* Structure Identifier */
 #define MQCNO_STRUC_ID "CNO "

 /* Structure Identifier (array form) */
 #define MQCNO_STRUC_ID_ARRAY 'C','N','O',' '

 /* Structure Version Number */
 #define MQCNO_VERSION_1       1L
 #define MQCNO_VERSION_2       2L
 #define MQCNO_CURRENT_VERSION 2L

 /* Connect Options */
 #define MQCNO_STANDARD_BINDING 0x00000000L
 #define MQCNO_FASTPATH_BINDING 0x00000001L
 #define MQCNO_NONE             0x00000000L


 /*********************************************************************/
 /*  Values Related to MQDH Structure                                 */
 /*********************************************************************/

 /* Structure Identifier */
 #define MQDH_STRUC_ID "DH  "

 /* Structure Identifier (array form) */
 #define MQDH_STRUC_ID_ARRAY 'D','H',' ',' '

 /* Structure Version Number */
 #define MQDH_VERSION_1       1L
 #define MQDH_CURRENT_VERSION 1L

 /* General Flags */
 #define MQDHF_NEW_MSG_IDS 1L
 #define MQDHF_NONE        0L

 /* Put Message Record Flags */
 /* See values for "Put Message Record Fields" under MQPMO */


 /*********************************************************************/
 /*  Values Related to MQDLH Structure                                */
 /*********************************************************************/

 /* Structure Identifier */
 #define MQDLH_STRUC_ID "DLH "

 /* Structure Identifier (array form) */
 #define MQDLH_STRUC_ID_ARRAY 'D','L','H',' '

 /* Structure Version Number */
 #define MQDLH_VERSION_1       1L
 #define MQDLH_CURRENT_VERSION 1L


 /*********************************************************************/
 /*  Values Related to MQGMO Structure                                */
 /*********************************************************************/

 /* Structure Identifier */
 #define MQGMO_STRUC_ID "GMO "

 /* Structure Identifier (array form) */
 #define MQGMO_STRUC_ID_ARRAY 'G','M','O',' '

 /* Structure Version Number */
 #define MQGMO_VERSION_1       1L
 #define MQGMO_VERSION_2       2L
 #define MQGMO_VERSION_3       3L
 #define MQGMO_CURRENT_VERSION 3L

 /* Get-Message Options */
 #define MQGMO_WAIT                    0x00000001L
 #define MQGMO_NO_WAIT                 0x00000000L
 #define MQGMO_SYNCPOINT               0x00000002L
 #define MQGMO_SYNCPOINT_IF_PERSISTENT 0x00001000L
 #define MQGMO_NO_SYNCPOINT            0x00000004L
 #define MQGMO_MARK_SKIP_BACKOUT       0x00000080L
 #define MQGMO_BROWSE_FIRST            0x00000010L
 #define MQGMO_BROWSE_NEXT             0x00000020L
 #define MQGMO_BROWSE_MSG_UNDER_CURSOR 0x00000800L
 #define MQGMO_MSG_UNDER_CURSOR        0x00000100L
 #define MQGMO_LOCK                    0x00000200L
 #define MQGMO_UNLOCK                  0x00000400L
 #define MQGMO_ACCEPT_TRUNCATED_MSG    0x00000040L
 #define MQGMO_SET_SIGNAL              0x00000008L
 #define MQGMO_FAIL_IF_QUIESCING       0x00002000L
 #define MQGMO_CONVERT                 0x00004000L
 #define MQGMO_LOGICAL_ORDER           0x00008000L
 #define MQGMO_COMPLETE_MSG            0x00010000L
 #define MQGMO_ALL_MSGS_AVAILABLE      0x00020000L
 #define MQGMO_ALL_SEGMENTS_AVAILABLE  0x00040000L
 #define MQGMO_NONE                    0x00000000L

 /* Wait Interval */
 #define MQWI_UNLIMITED (-1L)

 /* Signal Values */
 #define MQEC_MSG_ARRIVED           2L
 #define MQEC_WAIT_INTERVAL_EXPIRED 3L
 #define MQEC_WAIT_CANCELED         4L
 #define MQEC_Q_MGR_QUIESCING       5L
 #define MQEC_CONNECTION_QUIESCING  6L

 /* Match Options */
 #define MQMO_MATCH_MSG_ID         0x00000001L
 #define MQMO_MATCH_CORREL_ID      0x00000002L
 #define MQMO_MATCH_GROUP_ID       0x00000004L
 #define MQMO_MATCH_MSG_SEQ_NUMBER 0x00000008L
 #define MQMO_MATCH_OFFSET         0x00000010L
 #define MQMO_MATCH_MSG_TOKEN      0x00000020L
 #define MQMO_NONE                 0x00000000L

 /* Group Status */
 #define MQGS_NOT_IN_GROUP      ' '
 #define MQGS_MSG_IN_GROUP      'G'
 #define MQGS_LAST_MSG_IN_GROUP 'L'

 /* Segment Status */
 #define MQSS_NOT_A_SEGMENT ' '
 #define MQSS_SEGMENT       'S'
 #define MQSS_LAST_SEGMENT  'L'

 /* Segmentation */
 #define MQSEG_INHIBITED ' '
 #define MQSEG_ALLOWED   'A'

 /* Message Token */
 #define MQMTOK_NONE "\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"

 /* Message Token (array form) */
 #define MQMTOK_NONE_ARRAY '\0','\0','\0','\0','\0','\0','\0','\0',\
                           '\0','\0','\0','\0','\0','\0','\0','\0'

 /* Returned Length */
 #define MQRL_UNDEFINED (-1L)


 /*********************************************************************/
 /*  Values Related to MQIIH Structure                                */
 /*********************************************************************/

 /* Structure Identifier */
 #define MQIIH_STRUC_ID "IIH "

 /* Structure Identifier (array form) */
 #define MQIIH_STRUC_ID_ARRAY 'I','I','H',' '

 /* Structure Version Number */
 #define MQIIH_VERSION_1       1L
 #define MQIIH_CURRENT_VERSION 1L

 /* Structure Length */
 #define MQIIH_LENGTH_1 84L

 /* Flags */
 #define MQIIH_NONE 0L

 /* Authenticator */
 #define MQIAUT_NONE "        "

 /* Authenticator (array form) */
 #define MQIAUT_NONE_ARRAY ' ',' ',' ',' ',' ',' ',' ',' '

 /* Transaction Instance Identifier */
 #define MQITII_NONE "\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"

 /* Transaction Instance Identifier (array form) */
 #define MQITII_NONE_ARRAY '\0','\0','\0','\0','\0','\0','\0','\0',\
                           '\0','\0','\0','\0','\0','\0','\0','\0'

 /* Transaction State */
 #define MQITS_IN_CONVERSATION     'C'
 #define MQITS_NOT_IN_CONVERSATION ' '
 #define MQITS_ARCHITECTED         'A'

 /* Commit Mode */
 #define MQICM_COMMIT_THEN_SEND '0'
 #define MQICM_SEND_THEN_COMMIT '1'

 /* Security Scope */
 #define MQISS_CHECK 'C'
 #define MQISS_FULL  'F'


 /*********************************************************************/
 /*  Values Related to MQMD Structure                                 */
 /*********************************************************************/

 /* Structure Identifier */
 #define MQMD_STRUC_ID "MD  "

 /* Structure Identifier (array form) */
 #define MQMD_STRUC_ID_ARRAY 'M','D',' ',' '

 /* Structure Version Number */
 #define MQMD_VERSION_1       1L
 #define MQMD_VERSION_2       2L
 #define MQMD_CURRENT_VERSION 2L

 /* Report Options */
 #define MQRO_EXCEPTION                 0x01000000L
 #define MQRO_EXCEPTION_WITH_DATA       0x03000000L
 #define MQRO_EXCEPTION_WITH_FULL_DATA  0x07000000L
 #define MQRO_EXPIRATION                0x00200000L
 #define MQRO_EXPIRATION_WITH_DATA      0x00600000L
 #define MQRO_EXPIRATION_WITH_FULL_DATA 0x00e00000L
 #define MQRO_COA                       0x00000100L
 #define MQRO_COA_WITH_DATA             0x00000300L
 #define MQRO_COA_WITH_FULL_DATA        0x00000700L
 #define MQRO_COD                       0x00000800L
 #define MQRO_COD_WITH_DATA             0x00001800L
 #define MQRO_COD_WITH_FULL_DATA        0x00003800L
 #define MQRO_PAN                       0x00000001L
 #define MQRO_NAN                       0x00000002L
 #define MQRO_NEW_MSG_ID                0x00000000L
 #define MQRO_PASS_MSG_ID               0x00000080L
 #define MQRO_COPY_MSG_ID_TO_CORREL_ID  0x00000000L
 #define MQRO_PASS_CORREL_ID            0x00000040L
 #define MQRO_DEAD_LETTER_Q             0x00000000L
 #define MQRO_DISCARD_MSG               0x08000000L
 #define MQRO_NONE                      0x00000000L

 /* Report Options Masks */
 #define MQRO_REJECT_UNSUP_MASK         0x101c0000L
 #define MQRO_ACCEPT_UNSUP_MASK         0xefe000ffL
 #define MQRO_ACCEPT_UNSUP_IF_XMIT_MASK 0x0003ff00L

 /* Message Types */
 #define MQMT_SYSTEM_FIRST        1L
 #define MQMT_REQUEST             1L
 #define MQMT_REPLY               2L
 #define MQMT_DATAGRAM            8L
 #define MQMT_REPORT              4L
 #define MQMT_MQE_FIELDS_FROM_MQE 112L
 #define MQMT_MQE_FIELDS          113L
 #define MQMT_SYSTEM_LAST         65535L
 #define MQMT_APPL_FIRST          65536L
 #define MQMT_APPL_LAST           999999999L

 /* Expiry */
 #define MQEI_UNLIMITED (-1L)

 /* Feedback Values */
 #define MQFB_NONE                   0L
 #define MQFB_SYSTEM_FIRST           1L
 #define MQFB_QUIT                   256L
 #define MQFB_EXPIRATION             258L
 #define MQFB_COA                    259L
 #define MQFB_COD                    260L
 #define MQFB_CHANNEL_COMPLETED      262L
 #define MQFB_CHANNEL_FAIL_RETRY     263L
 #define MQFB_CHANNEL_FAIL           264L
 #define MQFB_APPL_CANNOT_BE_STARTED 265L
 #define MQFB_TM_ERROR               266L
 #define MQFB_APPL_TYPE_ERROR        267L
 #define MQFB_STOPPED_BY_MSG_EXIT    268L
 #define MQFB_XMIT_Q_MSG_ERROR       271L
 #define MQFB_PAN                    275L
 #define MQFB_NAN                    276L
 #define MQFB_STOPPED_BY_CHAD_EXIT   277L
 #define MQFB_STOPPED_BY_PUBSUB_EXIT 279L
 #define MQFB_NOT_A_REPOSITORY_MSG   280L
 #define MQFB_BIND_OPEN_CLUSRCVR_DEL 281L
 #define MQFB_DATA_LENGTH_ZERO       291L
 #define MQFB_DATA_LENGTH_NEGATIVE   292L
 #define MQFB_DATA_LENGTH_TOO_BIG    293L
 #define MQFB_BUFFER_OVERFLOW        294L
 #define MQFB_LENGTH_OFF_BY_ONE      295L
 #define MQFB_IIH_ERROR              296L
 #define MQFB_NOT_AUTHORIZED_FOR_IMS 298L
 #define MQFB_IMS_ERROR              300L
 #define MQFB_IMS_FIRST              301L
 #define MQFB_IMS_LAST               399L
 #define MQFB_CICS_INTERNAL_ERROR    401L
 #define MQFB_CICS_NOT_AUTHORIZED    402L
 #define MQFB_CICS_BRIDGE_FAILURE    403L
 #define MQFB_CICS_CORREL_ID_ERROR   404L
 #define MQFB_CICS_CCSID_ERROR       405L
 #define MQFB_CICS_ENCODING_ERROR    406L
 #define MQFB_CICS_CIH_ERROR         407L
 #define MQFB_CICS_UOW_ERROR         408L
 #define MQFB_CICS_COMMAREA_ERROR    409L
 #define MQFB_CICS_APPL_NOT_STARTED  410L
 #define MQFB_CICS_APPL_ABENDED      411L
 #define MQFB_CICS_DLQ_ERROR         412L
 #define MQFB_CICS_UOW_BACKED_OUT    413L
 #define MQFB_SYSTEM_LAST            65535L
 #define MQFB_APPL_FIRST             65536L
 #define MQFB_APPL_LAST              999999999L

 /* Encoding */
 #define MQENC_NATIVE 0x00000222L

 /* Encoding Masks */
 #define MQENC_INTEGER_MASK  0x0000000fL
 #define MQENC_DECIMAL_MASK  0x000000f0L
 #define MQENC_FLOAT_MASK    0x00000f00L
 #define MQENC_RESERVED_MASK 0xfffff000L

 /* Encodings for Binary Integers */
 #define MQENC_INTEGER_UNDEFINED 0x00000000L
 #define MQENC_INTEGER_NORMAL    0x00000001L
 #define MQENC_INTEGER_REVERSED  0x00000002L

 /* Encodings for Packed-Decimal Integers */
 #define MQENC_DECIMAL_UNDEFINED 0x00000000L
 #define MQENC_DECIMAL_NORMAL    0x00000010L
 #define MQENC_DECIMAL_REVERSED  0x00000020L

 /* Encodings for Floating-Point Numbers */
 #define MQENC_FLOAT_UNDEFINED     0x00000000L
 #define MQENC_FLOAT_IEEE_NORMAL   0x00000100L
 #define MQENC_FLOAT_IEEE_REVERSED 0x00000200L
 #define MQENC_FLOAT_S390          0x00000300L

 /* Coded Character-Set Identifiers */
 #define MQCCSI_UNDEFINED (0L)
 #define MQCCSI_DEFAULT   (0L)
 #define MQCCSI_Q_MGR     (0L)
 #define MQCCSI_INHERIT   (-2L)
 #define MQCCSI_EMBEDDED  (-1L)

 /* Formats */
 #define MQFMT_NONE               "        "
 #define MQFMT_ADMIN              "MQADMIN "
 #define MQFMT_CHANNEL_COMPLETED  "MQCHCOM "
 #define MQFMT_CICS               "MQCICS  "
 #define MQFMT_COMMAND_1          "MQCMD1  "
 #define MQFMT_COMMAND_2          "MQCMD2  "
 #define MQFMT_DEAD_LETTER_HEADER "MQDEAD  "
 #define MQFMT_DIST_HEADER        "MQHDIST "
 #define MQFMT_EVENT              "MQEVENT "
 #define MQFMT_IMS                "MQIMS   "
 #define MQFMT_IMS_VAR_STRING     "MQIMSVS "
 #define MQFMT_MD_EXTENSION       "MQHMDE  "
 #define MQFMT_PCF                "MQPCF   "
 #define MQFMT_REF_MSG_HEADER     "MQHREF  "
 #define MQFMT_RF_HEADER          "MQHRF   "
 #define MQFMT_RF_HEADER_2        "MQHRF2  "
 #define MQFMT_STRING             "MQSTR   "
 #define MQFMT_TRIGGER            "MQTRIG  "
 #define MQFMT_WORK_INFO_HEADER   "MQHWIH  "
 #define MQFMT_XMIT_Q_HEADER      "MQXMIT  "

 /* Formats (array form) */
 #define MQFMT_NONE_ARRAY               ' ',' ',' ',' ',' ',' ',' ',' '
 #define MQFMT_ADMIN_ARRAY              'M','Q','A','D','M','I','N',' '
 #define MQFMT_CHANNEL_COMPLETED_ARRAY  'M','Q','C','H','C','O','M',' '
 #define MQFMT_CICS_ARRAY               'M','Q','C','I','C','S',' ',' '
 #define MQFMT_COMMAND_1_ARRAY          'M','Q','C','M','D','1',' ',' '
 #define MQFMT_COMMAND_2_ARRAY          'M','Q','C','M','D','2',' ',' '
 #define MQFMT_DEAD_LETTER_HEADER_ARRAY 'M','Q','D','E','A','D',' ',' '
 #define MQFMT_DIST_HEADER_ARRAY        'M','Q','H','D','I','S','T',' '
 #define MQFMT_EVENT_ARRAY              'M','Q','E','V','E','N','T',' '
 #define MQFMT_IMS_ARRAY                'M','Q','I','M','S',' ',' ',' '
 #define MQFMT_IMS_VAR_STRING_ARRAY     'M','Q','I','M','S','V','S',' '
 #define MQFMT_MD_EXTENSION_ARRAY       'M','Q','H','M','D','E',' ',' '
 #define MQFMT_PCF_ARRAY                'M','Q','P','C','F',' ',' ',' '
 #define MQFMT_REF_MSG_HEADER_ARRAY     'M','Q','H','R','E','F',' ',' '
 #define MQFMT_RF_HEADER_ARRAY          'M','Q','H','R','F',' ',' ',' '
 #define MQFMT_RF_HEADER_2_ARRAY        'M','Q','H','R','F','2',' ',' '
 #define MQFMT_STRING_ARRAY             'M','Q','S','T','R',' ',' ',' '
 #define MQFMT_TRIGGER_ARRAY            'M','Q','T','R','I','G',' ',' '
 #define MQFMT_WORK_INFO_HEADER_ARRAY   'M','Q','H','W','I','H',' ',' '
 #define MQFMT_XMIT_Q_HEADER_ARRAY      'M','Q','X','M','I','T',' ',' '

 /* Priority */
 #define MQPRI_PRIORITY_AS_Q_DEF (-1L)

 /* Persistence Values */
 #define MQPER_NOT_PERSISTENT       0L
 #define MQPER_PERSISTENT           1L
 #define MQPER_PERSISTENCE_AS_Q_DEF 2L

 /* Message Identifier */
 #define MQMI_NONE "\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"

 /* Message Identifier (array form) */
 #define MQMI_NONE_ARRAY '\0','\0','\0','\0','\0','\0','\0','\0',\
                         '\0','\0','\0','\0','\0','\0','\0','\0',\
                         '\0','\0','\0','\0','\0','\0','\0','\0'

 /* Correlation Identifier */
 #define MQCI_NONE        "\0\0\0\0\0\0\0\0\0\0\0\0"\
                          "\0\0\0\0\0\0\0\0\0\0\0\0"
 #define MQCI_NEW_SESSION "\x41\x4d\x51\x21\x4e\x45\x57\x5f"\
                          "\x53\x45\x53\x53\x49\x4f\x4e\x5f"\
                          "\x43\x4f\x52\x52\x45\x4c\x49\x44"

 /* Correlation Identifier (array form) */
 #define MQCI_NONE_ARRAY        '\0','\0','\0','\0','\0','\0',\
                                '\0','\0','\0','\0','\0','\0',\
                                '\0','\0','\0','\0','\0','\0',\
                                '\0','\0','\0','\0','\0','\0'
 #define MQCI_NEW_SESSION_ARRAY '\x41','\x4d','\x51','\x21',\
                                '\x4e','\x45','\x57','\x5f',\
                                '\x53','\x45','\x53','\x53',\
                                '\x49','\x4f','\x4e','\x5f',\
                                '\x43','\x4f','\x52','\x52',\
                                '\x45','\x4c','\x49','\x44'

 /* Accounting Token */
 #define MQACT_NONE "\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"\
                    "\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"

 /* Accounting Token (array form) */
 #define MQACT_NONE_ARRAY '\0','\0','\0','\0','\0','\0','\0','\0',\
                          '\0','\0','\0','\0','\0','\0','\0','\0',\
                          '\0','\0','\0','\0','\0','\0','\0','\0',\
                          '\0','\0','\0','\0','\0','\0','\0','\0'

 /* Accounting Token Type */
 #define MQACTT_UNKNOWN             '\x00'
 #define MQACTT_CICS_LUOW_ID        '\x01'
 #define MQACTT_OS2_DEFAULT         '\x04'
 #define MQACTT_DOS_DEFAULT         '\x05'
 #define MQACTT_UNIX_NUMERIC_ID     '\x06'
 #define MQACTT_OS400_ACCOUNT_TOKEN '\x08'
 #define MQACTT_WINDOWS_DEFAULT     '\x09'
 #define MQACTT_NT_SECURITY_ID      '\x0b'
 #define MQACTT_USER                '\x19'

 /* Put Application Types */
 #define MQAT_UNKNOWN     (-1L)
 #define MQAT_NO_CONTEXT  0L
 #define MQAT_CICS        1L
 #define MQAT_MVS         2L
 #define MQAT_OS390       2L
 #define MQAT_IMS         3L
 #define MQAT_OS2         4L
 #define MQAT_DOS         5L
 #define MQAT_AIX         6L
 #define MQAT_UNIX        6L
 #define MQAT_QMGR        7L
 #define MQAT_OS400       8L
 #define MQAT_WINDOWS     9L
 #define MQAT_CICS_VSE    10L
 #define MQAT_WINDOWS_NT  11L
 #define MQAT_VMS         12L
 #define MQAT_GUARDIAN    13L
 #define MQAT_NSK         13L
 #define MQAT_VOS         14L
 #define MQAT_IMS_BRIDGE  19L
 #define MQAT_XCF         20L
 #define MQAT_CICS_BRIDGE 21L
 #define MQAT_NOTES_AGENT 22L
 #define MQAT_BROKER      26L
 #define MQAT_JAVA        28L
 #define MQAT_DQM         29L
 #define MQAT_DEFAULT     6L
 #define MQAT_USER_FIRST  65536L
 #define MQAT_USER_LAST   999999999L

 /* Group Identifier */
 #define MQGI_NONE "\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"

 /* Group Identifier (array form) */
 #define MQGI_NONE_ARRAY '\0','\0','\0','\0','\0','\0','\0','\0',\
                         '\0','\0','\0','\0','\0','\0','\0','\0',\
                         '\0','\0','\0','\0','\0','\0','\0','\0'

 /* Message Flags */
 #define MQMF_SEGMENTATION_INHIBITED 0x00000000L
 #define MQMF_SEGMENTATION_ALLOWED   0x00000001L
 #define MQMF_MSG_IN_GROUP           0x00000008L
 #define MQMF_LAST_MSG_IN_GROUP      0x00000010L
 #define MQMF_SEGMENT                0x00000002L
 #define MQMF_LAST_SEGMENT           0x00000004L
 #define MQMF_NONE                   0x00000000L

 /* Message Flags Masks */
 #define MQMF_REJECT_UNSUP_MASK         0x00000fffL
 #define MQMF_ACCEPT_UNSUP_MASK         0xfff00000L
 #define MQMF_ACCEPT_UNSUP_IF_XMIT_MASK 0x000ff000L

 /* Original Length */
 #define MQOL_UNDEFINED (-1L)


 /*********************************************************************/
 /*  Values Related to MQMDE Structure                                */
 /*********************************************************************/

 /* Structure Identifier */
 #define MQMDE_STRUC_ID "MDE "

 /* Structure Identifier (array form) */
 #define MQMDE_STRUC_ID_ARRAY 'M','D','E',' '

 /* Structure Version Number */
 #define MQMDE_VERSION_2       2L
 #define MQMDE_CURRENT_VERSION 2L

 /* Structure Length */
 #define MQMDE_LENGTH_2 72L

 /* General Flags */
 #define MQMDEF_NONE 0x00000000L


 /*********************************************************************/
 /*  Values Related to MQOD Structure                                 */
 /*********************************************************************/

 /* Structure Identifier */
 #define MQOD_STRUC_ID "OD  "

 /* Structure Identifier (array form) */
 #define MQOD_STRUC_ID_ARRAY 'O','D',' ',' '

 /* Structure Version Number */
 #define MQOD_VERSION_1       1L
 #define MQOD_VERSION_2       2L
 #define MQOD_VERSION_3       3L
 #define MQOD_CURRENT_VERSION 3L

 /* Structure Length */
#if defined(MQ_64_BIT)
 #define MQOD_CURRENT_LENGTH 344
#else
 #define MQOD_CURRENT_LENGTH 336L
#endif

 /* Object Types */
 #define MQOT_Q          1L
 #define MQOT_NAMELIST   2L
 #define MQOT_PROCESS    3L
 #define MQOT_Q_MGR      5L
 #define MQOT_CHANNEL    6L
 #define MQOT_RESERVED_1 7L

 /* Extended Object Types */
 #define MQOT_ALL               1001L
 #define MQOT_ALIAS_Q           1002L
 #define MQOT_MODEL_Q           1003L
 #define MQOT_LOCAL_Q           1004L
 #define MQOT_REMOTE_Q          1005L
 #define MQOT_SENDER_CHANNEL    1007L
 #define MQOT_SERVER_CHANNEL    1008L
 #define MQOT_REQUESTER_CHANNEL 1009L
 #define MQOT_RECEIVER_CHANNEL  1010L
 #define MQOT_CURRENT_CHANNEL   1011L
 #define MQOT_SAVED_CHANNEL     1012L
 #define MQOT_SVRCONN_CHANNEL   1013L
 #define MQOT_CLNTCONN_CHANNEL  1014L

 /* Security Identifier */
 #define MQSID_NONE "\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"\
                    "\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"

 /* Security Identifier (array form) */
 #define MQSID_NONE_ARRAY '\0','\0','\0','\0','\0','\0','\0','\0',\
                          '\0','\0','\0','\0','\0','\0','\0','\0',\
                          '\0','\0','\0','\0','\0','\0','\0','\0',\
                          '\0','\0','\0','\0','\0','\0','\0','\0',\
                          '\0','\0','\0','\0','\0','\0','\0','\0'

 /* Security Identifier Type */
 #define MQSIDT_NONE           '\x00'
 #define MQSIDT_NT_SECURITY_ID '\x01'


 /*********************************************************************/
 /*  Values Related to MQPMO Structure                                */
 /*********************************************************************/

 /* Structure Identifier */
 #define MQPMO_STRUC_ID "PMO "

 /* Structure Identifier (array form) */
 #define MQPMO_STRUC_ID_ARRAY 'P','M','O',' '

 /* Structure Version Number */
 #define MQPMO_VERSION_1       1L
 #define MQPMO_VERSION_2       2L
 #define MQPMO_CURRENT_VERSION 2L

 /* Structure Length */
#if defined(MQ_64_BIT)
 #define MQPMO_CURRENT_LENGTH 160
#else
 #define MQPMO_CURRENT_LENGTH 152L
#endif

 /* Put-Message Options */
 #define MQPMO_SYNCPOINT                0x00000002L
 #define MQPMO_NO_SYNCPOINT             0x00000004L
 #define MQPMO_NEW_MSG_ID               0x00000040L
 #define MQPMO_NEW_CORREL_ID            0x00000080L
 #define MQPMO_LOGICAL_ORDER            0x00008000L
 #define MQPMO_NO_CONTEXT               0x00004000L
 #define MQPMO_DEFAULT_CONTEXT          0x00000020L
 #define MQPMO_PASS_IDENTITY_CONTEXT    0x00000100L
 #define MQPMO_PASS_ALL_CONTEXT         0x00000200L
 #define MQPMO_SET_IDENTITY_CONTEXT     0x00000400L
 #define MQPMO_SET_ALL_CONTEXT          0x00000800L
 #define MQPMO_ALTERNATE_USER_AUTHORITY 0x00001000L
 #define MQPMO_FAIL_IF_QUIESCING        0x00002000L
 #define MQPMO_NONE                     0x00000000L

 /* Put Message Record Fields */
 #define MQPMRF_MSG_ID           1L
 #define MQPMRF_CORREL_ID        2L
 #define MQPMRF_GROUP_ID         4L
 #define MQPMRF_FEEDBACK         8L
 #define MQPMRF_ACCOUNTING_TOKEN 16L
 #define MQPMRF_NONE             0L

 /*********************************************************************/
 /*  Values Related to MQRFH Structure                                */
 /*********************************************************************/

 /* Structure Identifier */
 #define MQRFH_STRUC_ID "RFH "

 /* Structure Identifier (array form) */
 #define MQRFH_STRUC_ID_ARRAY 'R','F','H',' '

 /* Structure Version Number */
 #define MQRFH_VERSION_1 1L
 #define MQRFH_VERSION_2 2L

 /* Structure Length */
 #define MQRFH_STRUC_LENGTH_FIXED   32L
 #define MQRFH_STRUC_LENGTH_FIXED_2 36L

 /* Flags */
 #define MQRFH_NONE 0x00000000L

 /* Names for Name/Value String */
 #define MQNVS_APPL_TYPE "OPT_APP_GRP "
 #define MQNVS_MSG_TYPE  "OPT_MSG_TYPE "



 /*********************************************************************/
 /*  Values Related to MQRMH Structure                                */
 /*********************************************************************/

 /* Structure Identifier */
 #define MQRMH_STRUC_ID "RMH "

 /* Structure Identifier (array form) */
 #define MQRMH_STRUC_ID_ARRAY 'R','M','H',' '

 /* Structure Version Number */
 #define MQRMH_VERSION_1       1L
 #define MQRMH_CURRENT_VERSION 1L

 /* Flags */
 #define MQRMHF_LAST     0x00000001L
 #define MQRMHF_NOT_LAST 0x00000000L

 /* Object Instance Identifier */
 #define MQOII_NONE "\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"

 /* Object Instance Identifier (array form) */
 #define MQOII_NONE_ARRAY '\0','\0','\0','\0','\0','\0','\0','\0',\
                          '\0','\0','\0','\0','\0','\0','\0','\0',\
                          '\0','\0','\0','\0','\0','\0','\0','\0'


 /*********************************************************************/
 /*  Values Related to MQTM Structure                                 */
 /*********************************************************************/

 /* Structure Identifier */
 #define MQTM_STRUC_ID "TM  "

 /* Structure Identifier (array form) */
 #define MQTM_STRUC_ID_ARRAY 'T','M',' ',' '

 /* Structure Version Number */
 #define MQTM_VERSION_1       1L
 #define MQTM_CURRENT_VERSION 1L


 /*********************************************************************/
 /*  Values Related to MQTMC2 Structure                               */
 /*********************************************************************/

 /* Structure Identifier */
 #define MQTMC_STRUC_ID "TMC "

 /* Structure Identifier (array form) */
 #define MQTMC_STRUC_ID_ARRAY 'T','M','C',' '

 /* Structure Version Number */
 #define MQTMC_VERSION_1       "   1"
 #define MQTMC_VERSION_2       "   2"
 #define MQTMC_CURRENT_VERSION "   2"

 /* Structure Version Number (array form) */
 #define MQTMC_VERSION_1_ARRAY       ' ',' ',' ','1'
 #define MQTMC_VERSION_2_ARRAY       ' ',' ',' ','2'
 #define MQTMC_CURRENT_VERSION_ARRAY ' ',' ',' ','2'


 /*********************************************************************/
 /*  Values Related to MQWIH Structure                                */
 /*********************************************************************/

 /* Structure Identifier */
 #define MQWIH_STRUC_ID "WIH "

 /* Structure Identifier (array form) */
 #define MQWIH_STRUC_ID_ARRAY 'W','I','H',' '

 /* Structure Version Number */
 #define MQWIH_VERSION_1       1L
 #define MQWIH_CURRENT_VERSION 1L

 /* Structure Length */
 #define MQWIH_LENGTH_1       120L
 #define MQWIH_CURRENT_LENGTH 120L

 /* Flags */
 #define MQWIH_NONE 0L


 /*********************************************************************/
 /*  Values Related to MQXQH Structure                                */
 /*********************************************************************/

 /* Structure Identifier */
 #define MQXQH_STRUC_ID "XQH "

 /* Structure Identifier (array form) */
 #define MQXQH_STRUC_ID_ARRAY 'X','Q','H',' '

 /* Structure Version Number */
 #define MQXQH_VERSION_1       1L
 #define MQXQH_CURRENT_VERSION 1L


 /*********************************************************************/
 /*  Values Related to MQCLOSE Function                               */
 /*********************************************************************/

 /* Object Handle */
 #define MQHO_UNUSABLE_HOBJ (-1L)
 #define MQHO_NONE          0L

 /* Close Options */
 #define MQCO_NONE         0L
 #define MQCO_DELETE       1L
 #define MQCO_DELETE_PURGE 2L


 /*********************************************************************/
 /*  Values Related to MQINQ Function                                 */
 /*********************************************************************/

 /* Character-Attribute Selectors */
 #define MQCA_ALTERATION_DATE       2027L
 #define MQCA_ALTERATION_TIME       2028L
 #define MQCA_APPL_ID               2001L
 #define MQCA_BACKOUT_REQ_Q_NAME    2019L
 #define MQCA_BASE_Q_NAME           2002L
 #define MQCA_CF_STRUC_NAME         2039L
 #define MQCA_CHANNEL_AUTO_DEF_EXIT 2026L
 #define MQCA_CLUSTER_DATE          2037L
 #define MQCA_CLUSTER_NAME          2029L
 #define MQCA_CLUSTER_NAMELIST      2030L
 #define MQCA_CLUSTER_Q_MGR_NAME    2031L
 #define MQCA_CLUSTER_TIME          2038L
 #define MQCA_CLUSTER_WORKLOAD_DATA 2034L
 #define MQCA_CLUSTER_WORKLOAD_EXIT 2033L
 #define MQCA_COMMAND_INPUT_Q_NAME  2003L
 #define MQCA_CREATION_DATE         2004L
 #define MQCA_CREATION_TIME         2005L
 #define MQCA_DEAD_LETTER_Q_NAME    2006L
 #define MQCA_DEF_XMIT_Q_NAME       2025L
 #define MQCA_ENV_DATA              2007L
 #define MQCA_FIRST                 2001L
 #define MQCA_IGQ_USER_ID           2041L
 #define MQCA_INITIATION_Q_NAME     2008L
 #define MQCA_LAST                  4000L
 #define MQCA_LAST_USED             2041L
 #define MQCA_NAMELIST_DESC         2009L
 #define MQCA_NAMELIST_NAME         2010L
 #define MQCA_NAMES                 2020L
 #define MQCA_PROCESS_DESC          2011L
 #define MQCA_PROCESS_NAME          2012L
 #define MQCA_Q_DESC                2013L
 #define MQCA_Q_MGR_DESC            2014L
 #define MQCA_Q_MGR_IDENTIFIER      2032L
 #define MQCA_Q_MGR_NAME            2015L
 #define MQCA_Q_NAME                2016L
 #define MQCA_QSG_NAME              2040L
 #define MQCA_REMOTE_Q_MGR_NAME     2017L
 #define MQCA_REMOTE_Q_NAME         2018L
 #define MQCA_REPOSITORY_NAME       2035L
 #define MQCA_REPOSITORY_NAMELIST   2036L
 #define MQCA_STORAGE_CLASS         2022L
 #define MQCA_TRIGGER_DATA          2023L
 #define MQCA_USER_DATA             2021L
 #define MQCA_USER_LIST             4000L
 #define MQCA_XMIT_Q_NAME           2024L

 /* Integer-Attribute Selectors */
 #define MQIA_APPL_TYPE                1L
 #define MQIA_ARCHIVE                  60L
 #define MQIA_AUTHORITY_EVENT          47L
 #define MQIA_BACKOUT_THRESHOLD        22L
 #define MQIA_CHANNEL_AUTO_DEF         55L
 #define MQIA_CHANNEL_AUTO_DEF_EVENT   56L
 #define MQIA_CLUSTER_Q_TYPE           59L
 #define MQIA_CLUSTER_WORKLOAD_LENGTH  58L
 #define MQIA_CODED_CHAR_SET_ID        2L
 #define MQIA_COMMAND_LEVEL            31L
 #define MQIA_CURRENT_Q_DEPTH          3L
 #define MQIA_DEF_BIND                 61L
 #define MQIA_DEF_INPUT_OPEN_OPTION    4L
 #define MQIA_DEF_PERSISTENCE          5L
 #define MQIA_DEF_PRIORITY             6L
 #define MQIA_DEFINITION_TYPE          7L
 #define MQIA_DIST_LISTS               34L
 #define MQIA_FIRST                    1L
 #define MQIA_HARDEN_GET_BACKOUT       8L
 #define MQIA_HIGH_Q_DEPTH             36L
 #define MQIA_IGQ_PUT_AUTHORITY        65L
 #define MQIA_INDEX_TYPE               57L
 #define MQIA_INHIBIT_EVENT            48L
 #define MQIA_INHIBIT_GET              9L
 #define MQIA_INHIBIT_PUT              10L
 #define MQIA_INTRA_GROUP_QUEUING      64L
 #define MQIA_LAST                     2000L
 #define MQIA_LAST_USED                65L
 #define MQIA_LOCAL_EVENT              49L
 #define MQIA_MAX_HANDLES              11L
 #define MQIA_MAX_MSG_LENGTH           13L
 #define MQIA_MAX_PRIORITY             14L
 #define MQIA_MAX_Q_DEPTH              15L
 #define MQIA_MAX_UNCOMMITTED_MSGS     33L
 #define MQIA_MSG_DELIVERY_SEQUENCE    16L
 #define MQIA_MSG_DEQ_COUNT            38L
 #define MQIA_MSG_ENQ_COUNT            37L
 #define MQIA_NAME_COUNT               19L
 #define MQIA_OPEN_INPUT_COUNT         17L
 #define MQIA_OPEN_OUTPUT_COUNT        18L
 #define MQIA_PERFORMANCE_EVENT        53L
 #define MQIA_PLATFORM                 32L
 #define MQIA_Q_DEPTH_HIGH_EVENT       43L
 #define MQIA_Q_DEPTH_HIGH_LIMIT       40L
 #define MQIA_Q_DEPTH_LOW_EVENT        44L
 #define MQIA_Q_DEPTH_LOW_LIMIT        41L
 #define MQIA_Q_DEPTH_MAX_EVENT        42L
 #define MQIA_Q_SERVICE_INTERVAL       54L
 #define MQIA_Q_SERVICE_INTERVAL_EVENT 46L
 #define MQIA_Q_TYPE                   20L
 #define MQIA_QSG_DISP                 63L
 #define MQIA_REMOTE_EVENT             50L
 #define MQIA_RETENTION_INTERVAL       21L
 #define MQIA_SCOPE                    45L
 #define MQIA_SHAREABILITY             23L
 #define MQIA_START_STOP_EVENT         52L
 #define MQIA_SYNCPOINT                30L
 #define MQIA_TIME_SINCE_RESET         35L
 #define MQIA_TRIGGER_CONTROL          24L
 #define MQIA_TRIGGER_DEPTH            29L
 #define MQIA_TRIGGER_INTERVAL         25L
 #define MQIA_TRIGGER_MSG_PRIORITY     26L
 #define MQIA_TRIGGER_TYPE             28L
 #define MQIA_USAGE                    12L
 #define MQIA_USER_LIST                2000L

 /* Integer Attribute Value Denoting "Not Applicable" */
 #define MQIAV_NOT_APPLICABLE (-1L)
 #define MQIAV_UNDEFINED      (-2L)


 /*********************************************************************/
 /*  Values Related to MQOPEN Function                                */
 /*********************************************************************/

 /* Open Options */
 #define MQOO_INPUT_AS_Q_DEF           0x00000001L
 #define MQOO_INPUT_SHARED             0x00000002L
 #define MQOO_INPUT_EXCLUSIVE          0x00000004L
 #define MQOO_BROWSE                   0x00000008L
 #define MQOO_OUTPUT                   0x00000010L
 #define MQOO_INQUIRE                  0x00000020L
 #define MQOO_SET                      0x00000040L
 #define MQOO_BIND_ON_OPEN             0x00004000L
 #define MQOO_BIND_NOT_FIXED           0x00008000L
 #define MQOO_BIND_AS_Q_DEF            0x00000000L
 #define MQOO_SAVE_ALL_CONTEXT         0x00000080L
 #define MQOO_PASS_IDENTITY_CONTEXT    0x00000100L
 #define MQOO_PASS_ALL_CONTEXT         0x00000200L
 #define MQOO_SET_IDENTITY_CONTEXT     0x00000400L
 #define MQOO_SET_ALL_CONTEXT          0x00000800L
 #define MQOO_ALTERNATE_USER_AUTHORITY 0x00001000L
 #define MQOO_FAIL_IF_QUIESCING        0x00002000L
 #define MQOO_RESOLVE_NAMES            0x00010000L


 /*********************************************************************/
 /*  Values Related to All Functions                                  */
 /*********************************************************************/

 /* Function Entry-Point and Pointer Attributes */
 #define MQENTRY
 #define MQPOINTER *


 /* Connection Handle */
 #define MQHC_DEF_HCONN      0L
 #define MQHC_UNUSABLE_HCONN (-1L)

 /* String Lengths */
 #define MQ_ABEND_CODE_LENGTH         4L
 #define MQ_ACCOUNTING_TOKEN_LENGTH   32L
 #define MQ_APPL_IDENTITY_DATA_LENGTH 32L
 #define MQ_APPL_NAME_LENGTH          28L
 #define MQ_APPL_ORIGIN_DATA_LENGTH   4L
 #define MQ_ATTENTION_ID_LENGTH       4L
 #define MQ_AUTHENTICATOR_LENGTH      8L
 #define MQ_BRIDGE_NAME_LENGTH        24L
 #define MQ_CANCEL_CODE_LENGTH        4L
 #define MQ_CF_STRUC_NAME_LENGTH      12L
 #define MQ_CHANNEL_DATE_LENGTH       12L
 #define MQ_CHANNEL_DESC_LENGTH       64L
 #define MQ_CHANNEL_NAME_LENGTH       20L
 #define MQ_CHANNEL_TIME_LENGTH       8L
 #define MQ_CLUSTER_NAME_LENGTH       48L
 #define MQ_CONN_NAME_LENGTH          264L
 #define MQ_CONN_TAG_LENGTH           128L
 #define MQ_CORREL_ID_LENGTH          24L
 #define MQ_CREATION_DATE_LENGTH      12L
 #define MQ_CREATION_TIME_LENGTH      8L
 #define MQ_DATE_LENGTH               12L
 #define MQ_EXIT_DATA_LENGTH          32L
 #define MQ_EXIT_NAME_LENGTH          128L
 #define MQ_EXIT_USER_AREA_LENGTH     16L
 #define MQ_FACILITY_LENGTH           8L
 #define MQ_FACILITY_LIKE_LENGTH      4L
 #define MQ_FORMAT_LENGTH             8L
 #define MQ_FUNCTION_LENGTH           4L
 #define MQ_GROUP_ID_LENGTH           24L
 #define MQ_LTERM_OVERRIDE_LENGTH     8L
 #define MQ_LUWID_LENGTH              16L
 #define MQ_MAX_EXIT_NAME_LENGTH      128L
 #define MQ_MAX_MCA_USER_ID_LENGTH    64L
 #define MQ_MCA_JOB_NAME_LENGTH       28L
 #define MQ_MCA_NAME_LENGTH           20L
 #define MQ_MCA_USER_ID_LENGTH        12L
 #define MQ_MFS_MAP_NAME_LENGTH       8L
 #define MQ_MODE_NAME_LENGTH          8L
 #define MQ_MSG_HEADER_LENGTH         4000L
 #define MQ_MSG_ID_LENGTH             24L
 #define MQ_MSG_TOKEN_LENGTH          16L
 #define MQ_NAMELIST_DESC_LENGTH      64L
 #define MQ_NAMELIST_NAME_LENGTH      48L
 #define MQ_OBJECT_INSTANCE_ID_LENGTH 24L
 #define MQ_OBJECT_NAME_LENGTH        48L
 #define MQ_PASSWORD_LENGTH           12L
 #define MQ_PROCESS_APPL_ID_LENGTH    256L
 #define MQ_PROCESS_DESC_LENGTH       64L
 #define MQ_PROCESS_ENV_DATA_LENGTH   128L
 #define MQ_PROCESS_NAME_LENGTH       48L
 #define MQ_PROCESS_USER_DATA_LENGTH  128L
 #define MQ_PUT_APPL_NAME_LENGTH      28L
 #define MQ_PUT_DATE_LENGTH           8L
 #define MQ_PUT_TIME_LENGTH           8L
 #define MQ_Q_DESC_LENGTH             64L
 #define MQ_Q_MGR_DESC_LENGTH         64L
 #define MQ_Q_MGR_IDENTIFIER_LENGTH   48L
 #define MQ_Q_MGR_NAME_LENGTH         48L
 #define MQ_Q_NAME_LENGTH             48L
 #define MQ_QSG_NAME_LENGTH           4L
 #define MQ_REMOTE_SYS_ID_LENGTH      4L
 #define MQ_SECURITY_ID_LENGTH        40L
 #define MQ_SERVICE_NAME_LENGTH       32L
 #define MQ_SERVICE_STEP_LENGTH       8L
 #define MQ_SHORT_CONN_NAME_LENGTH    20L
 #define MQ_START_CODE_LENGTH         4L
 #define MQ_STORAGE_CLASS_LENGTH      8L
 #define MQ_TIME_LENGTH               8L
 #define MQ_TOTAL_EXIT_DATA_LENGTH    999L
 #define MQ_TOTAL_EXIT_NAME_LENGTH    999L
 #define MQ_TP_NAME_LENGTH            64L
 #define MQ_TRAN_INSTANCE_ID_LENGTH   16L
 #define MQ_TRANSACTION_ID_LENGTH     4L
 #define MQ_TRIGGER_DATA_LENGTH       64L
 #define MQ_USER_ID_LENGTH            12L
 #define MQ_EXIT_PD_AREA_LENGTH       48

 /* Completion Codes */
 #define MQCC_OK      0L
 #define MQCC_WARNING 1L
 #define MQCC_FAILED  2L
 #define MQCC_UNKNOWN (-1L)

 /* Reason Codes */
 #define MQRC_NONE                      0L
 #define MQRC_ALIAS_BASE_Q_TYPE_ERROR   2001L
 #define MQRC_ALREADY_CONNECTED         2002L
 #define MQRC_BACKED_OUT                2003L
 #define MQRC_BUFFER_ERROR              2004L
 #define MQRC_BUFFER_LENGTH_ERROR       2005L
 #define MQRC_CHAR_ATTR_LENGTH_ERROR    2006L
 #define MQRC_CHAR_ATTRS_ERROR          2007L
 #define MQRC_CHAR_ATTRS_TOO_SHORT      2008L
 #define MQRC_CONNECTION_BROKEN         2009L
 #define MQRC_DATA_LENGTH_ERROR         2010L
 #define MQRC_DYNAMIC_Q_NAME_ERROR      2011L
 #define MQRC_ENVIRONMENT_ERROR         2012L
 #define MQRC_EXPIRY_ERROR              2013L
 #define MQRC_FEEDBACK_ERROR            2014L
 #define MQRC_GET_INHIBITED             2016L
 #define MQRC_HANDLE_NOT_AVAILABLE      2017L
 #define MQRC_HCONN_ERROR               2018L
 #define MQRC_HOBJ_ERROR                2019L
 #define MQRC_INHIBIT_VALUE_ERROR       2020L
 #define MQRC_INT_ATTR_COUNT_ERROR      2021L
 #define MQRC_INT_ATTR_COUNT_TOO_SMALL  2022L
 #define MQRC_INT_ATTRS_ARRAY_ERROR     2023L
 #define MQRC_SYNCPOINT_LIMIT_REACHED   2024L
 #define MQRC_MAX_CONNS_LIMIT_REACHED   2025L
 #define MQRC_MD_ERROR                  2026L
 #define MQRC_MISSING_REPLY_TO_Q        2027L
 #define MQRC_MSG_TYPE_ERROR            2029L
 #define MQRC_MSG_TOO_BIG_FOR_Q         2030L
 #define MQRC_MSG_TOO_BIG_FOR_Q_MGR     2031L
 #define MQRC_NO_MSG_AVAILABLE          2033L
 #define MQRC_NO_MSG_UNDER_CURSOR       2034L
 #define MQRC_NOT_AUTHORIZED            2035L
 #define MQRC_NOT_OPEN_FOR_BROWSE       2036L
 #define MQRC_NOT_OPEN_FOR_INPUT        2037L
 #define MQRC_NOT_OPEN_FOR_INQUIRE      2038L
 #define MQRC_NOT_OPEN_FOR_OUTPUT       2039L
 #define MQRC_NOT_OPEN_FOR_SET          2040L
 #define MQRC_OBJECT_CHANGED            2041L
 #define MQRC_OBJECT_IN_USE             2042L
 #define MQRC_OBJECT_TYPE_ERROR         2043L
 #define MQRC_OD_ERROR                  2044L
 #define MQRC_OPTION_NOT_VALID_FOR_TYPE 2045L
 #define MQRC_OPTIONS_ERROR             2046L
 #define MQRC_PERSISTENCE_ERROR         2047L
 #define MQRC_PERSISTENT_NOT_ALLOWED    2048L
 #define MQRC_PRIORITY_EXCEEDS_MAXIMUM  2049L
 #define MQRC_PRIORITY_ERROR            2050L
 #define MQRC_PUT_INHIBITED             2051L
 #define MQRC_Q_DELETED                 2052L
 #define MQRC_Q_FULL                    2053L
 #define MQRC_Q_NOT_EMPTY               2055L
 #define MQRC_Q_SPACE_NOT_AVAILABLE     2056L
 #define MQRC_Q_TYPE_ERROR              2057L
 #define MQRC_Q_MGR_NAME_ERROR          2058L
 #define MQRC_Q_MGR_NOT_AVAILABLE       2059L
 #define MQRC_REPORT_OPTIONS_ERROR      2061L
 #define MQRC_SECOND_MARK_NOT_ALLOWED   2062L
 #define MQRC_SECURITY_ERROR            2063L
 #define MQRC_SELECTOR_COUNT_ERROR      2065L
 #define MQRC_SELECTOR_LIMIT_EXCEEDED   2066L
 #define MQRC_SELECTOR_ERROR            2067L
 #define MQRC_SELECTOR_NOT_FOR_TYPE     2068L
 #define MQRC_SIGNAL_OUTSTANDING        2069L
 #define MQRC_SIGNAL_REQUEST_ACCEPTED   2070L
 #define MQRC_STORAGE_NOT_AVAILABLE     2071L
 #define MQRC_SYNCPOINT_NOT_AVAILABLE   2072L
 #define MQRC_TRIGGER_CONTROL_ERROR     2075L
 #define MQRC_TRIGGER_DEPTH_ERROR       2076L
 #define MQRC_TRIGGER_MSG_PRIORITY_ERR  2077L
 #define MQRC_TRIGGER_TYPE_ERROR        2078L
 #define MQRC_TRUNCATED_MSG_ACCEPTED    2079L
 #define MQRC_TRUNCATED_MSG_FAILED      2080L
 #define MQRC_UNKNOWN_ALIAS_BASE_Q      2082L
 #define MQRC_UNKNOWN_OBJECT_NAME       2085L
 #define MQRC_UNKNOWN_OBJECT_Q_MGR      2086L
 #define MQRC_UNKNOWN_REMOTE_Q_MGR      2087L
 #define MQRC_WAIT_INTERVAL_ERROR       2090L
 #define MQRC_XMIT_Q_TYPE_ERROR         2091L
 #define MQRC_XMIT_Q_USAGE_ERROR        2092L
 #define MQRC_NOT_OPEN_FOR_PASS_ALL     2093L
 #define MQRC_NOT_OPEN_FOR_PASS_IDENT   2094L
 #define MQRC_NOT_OPEN_FOR_SET_ALL      2095L
 #define MQRC_NOT_OPEN_FOR_SET_IDENT    2096L
 #define MQRC_CONTEXT_HANDLE_ERROR      2097L
 #define MQRC_CONTEXT_NOT_AVAILABLE     2098L
 #define MQRC_SIGNAL1_ERROR             2099L
 #define MQRC_OBJECT_ALREADY_EXISTS     2100L
 #define MQRC_OBJECT_DAMAGED            2101L
 #define MQRC_RESOURCE_PROBLEM          2102L
 #define MQRC_ANOTHER_Q_MGR_CONNECTED   2103L
 #define MQRC_UNKNOWN_REPORT_OPTION     2104L
 #define MQRC_STORAGE_CLASS_ERROR       2105L
 #define MQRC_COD_NOT_VALID_FOR_XCF_Q   2106L
 #define MQRC_XWAIT_CANCELED            2107L
 #define MQRC_XWAIT_ERROR               2108L
 #define MQRC_SUPPRESSED_BY_EXIT        2109L
 #define MQRC_FORMAT_ERROR              2110L
 #define MQRC_SOURCE_CCSID_ERROR        2111L
 #define MQRC_SOURCE_INTEGER_ENC_ERROR  2112L
 #define MQRC_SOURCE_DECIMAL_ENC_ERROR  2113L
 #define MQRC_SOURCE_FLOAT_ENC_ERROR    2114L
 #define MQRC_TARGET_CCSID_ERROR        2115L
 #define MQRC_TARGET_INTEGER_ENC_ERROR  2116L
 #define MQRC_TARGET_DECIMAL_ENC_ERROR  2117L
 #define MQRC_TARGET_FLOAT_ENC_ERROR    2118L
 #define MQRC_NOT_CONVERTED             2119L
 #define MQRC_CONVERTED_MSG_TOO_BIG     2120L
 #define MQRC_TRUNCATED                 2120L
 #define MQRC_NO_EXTERNAL_PARTICIPANTS  2121L
 #define MQRC_PARTICIPANT_NOT_AVAILABLE 2122L
 #define MQRC_OUTCOME_MIXED             2123L
 #define MQRC_OUTCOME_PENDING           2124L
 #define MQRC_BRIDGE_STARTED            2125L
 #define MQRC_BRIDGE_STOPPED            2126L
 #define MQRC_ADAPTER_STORAGE_SHORTAGE  2127L
 #define MQRC_UOW_IN_PROGRESS           2128L
 #define MQRC_ADAPTER_CONN_LOAD_ERROR   2129L
 #define MQRC_ADAPTER_SERV_LOAD_ERROR   2130L
 #define MQRC_ADAPTER_DEFS_ERROR        2131L
 #define MQRC_ADAPTER_DEFS_LOAD_ERROR   2132L
 #define MQRC_ADAPTER_CONV_LOAD_ERROR   2133L
 #define MQRC_BO_ERROR                  2134L
 #define MQRC_DH_ERROR                  2135L
 #define MQRC_MULTIPLE_REASONS          2136L
 #define MQRC_OPEN_FAILED               2137L
 #define MQRC_ADAPTER_DISC_LOAD_ERROR   2138L
 #define MQRC_CNO_ERROR                 2139L
 #define MQRC_CICS_WAIT_FAILED          2140L
 #define MQRC_DLH_ERROR                 2141L
 #define MQRC_HEADER_ERROR              2142L
 #define MQRC_SOURCE_LENGTH_ERROR       2143L
 #define MQRC_TARGET_LENGTH_ERROR       2144L
 #define MQRC_SOURCE_BUFFER_ERROR       2145L
 #define MQRC_TARGET_BUFFER_ERROR       2146L
 #define MQRC_IIH_ERROR                 2148L
 #define MQRC_PCF_ERROR                 2149L
 #define MQRC_DBCS_ERROR                2150L
 #define MQRC_OBJECT_NAME_ERROR         2152L
 #define MQRC_OBJECT_Q_MGR_NAME_ERROR   2153L
 #define MQRC_RECS_PRESENT_ERROR        2154L
 #define MQRC_OBJECT_RECORDS_ERROR      2155L
 #define MQRC_RESPONSE_RECORDS_ERROR    2156L
 #define MQRC_ASID_MISMATCH             2157L
 #define MQRC_PMO_RECORD_FLAGS_ERROR    2158L
 #define MQRC_PUT_MSG_RECORDS_ERROR     2159L
 #define MQRC_CONN_ID_IN_USE            2160L
 #define MQRC_Q_MGR_QUIESCING           2161L
 #define MQRC_Q_MGR_STOPPING            2162L
 #define MQRC_DUPLICATE_RECOV_COORD     2163L
 #define MQRC_PMO_ERROR                 2173L
 #define MQRC_API_EXIT_NOT_FOUND        2182L
 #define MQRC_API_EXIT_LOAD_ERROR       2183L
 #define MQRC_REMOTE_Q_NAME_ERROR       2184L
 #define MQRC_INCONSISTENT_PERSISTENCE  2185L
 #define MQRC_GMO_ERROR                 2186L
 #define MQRC_CICS_BRIDGE_RESTRICTION   2187L
 #define MQRC_STOPPED_BY_CLUSTER_EXIT   2188L
 #define MQRC_CLUSTER_RESOLUTION_ERROR  2189L
 #define MQRC_CONVERTED_STRING_TOO_BIG  2190L
 #define MQRC_TMC_ERROR                 2191L
 #define MQRC_PAGESET_FULL              2192L
 #define MQRC_STORAGE_MEDIUM_FULL       2192L
 #define MQRC_PAGESET_ERROR             2193L
 #define MQRC_NAME_NOT_VALID_FOR_TYPE   2194L
 #define MQRC_UNEXPECTED_ERROR          2195L
 #define MQRC_UNKNOWN_XMIT_Q            2196L
 #define MQRC_UNKNOWN_DEF_XMIT_Q        2197L
 #define MQRC_DEF_XMIT_Q_TYPE_ERROR     2198L
 #define MQRC_DEF_XMIT_Q_USAGE_ERROR    2199L
 #define MQRC_NAME_IN_USE               2201L
 #define MQRC_CONNECTION_QUIESCING      2202L
 #define MQRC_CONNECTION_STOPPING       2203L
 #define MQRC_ADAPTER_NOT_AVAILABLE     2204L
 #define MQRC_MSG_ID_ERROR              2206L
 #define MQRC_CORREL_ID_ERROR           2207L
 #define MQRC_FILE_SYSTEM_ERROR         2208L
 #define MQRC_NO_MSG_LOCKED             2209L
 #define MQRC_FILE_NOT_AUDITED          2216L
 #define MQRC_CONNECTION_NOT_AUTHORIZED 2217L
 #define MQRC_MSG_TOO_BIG_FOR_CHANNEL   2218L
 #define MQRC_CALL_IN_PROGRESS          2219L
 #define MQRC_RMH_ERROR                 2220L
 #define MQRC_Q_MGR_ACTIVE              2222L
 #define MQRC_Q_MGR_NOT_ACTIVE          2223L
 #define MQRC_Q_DEPTH_HIGH              2224L
 #define MQRC_Q_DEPTH_LOW               2225L
 #define MQRC_Q_SERVICE_INTERVAL_HIGH   2226L
 #define MQRC_Q_SERVICE_INTERVAL_OK     2227L
 #define MQRC_UNIT_OF_WORK_NOT_STARTED  2232L
 #define MQRC_CHANNEL_AUTO_DEF_OK       2233L
 #define MQRC_CHANNEL_AUTO_DEF_ERROR    2234L
 #define MQRC_CFH_ERROR                 2235L
 #define MQRC_CFIL_ERROR                2236L
 #define MQRC_CFIN_ERROR                2237L
 #define MQRC_CFSL_ERROR                2238L
 #define MQRC_CFST_ERROR                2239L
 #define MQRC_INCOMPLETE_GROUP          2241L
 #define MQRC_INCOMPLETE_MSG            2242L
 #define MQRC_INCONSISTENT_CCSIDS       2243L
 #define MQRC_INCONSISTENT_ENCODINGS    2244L
 #define MQRC_INCONSISTENT_UOW          2245L
 #define MQRC_INVALID_MSG_UNDER_CURSOR  2246L
 #define MQRC_MATCH_OPTIONS_ERROR       2247L
 #define MQRC_MDE_ERROR                 2248L
 #define MQRC_MSG_FLAGS_ERROR           2249L
 #define MQRC_MSG_SEQ_NUMBER_ERROR      2250L
 #define MQRC_OFFSET_ERROR              2251L
 #define MQRC_ORIGINAL_LENGTH_ERROR     2252L
 #define MQRC_SEGMENT_LENGTH_ZERO       2253L
 #define MQRC_UOW_NOT_AVAILABLE         2255L
 #define MQRC_WRONG_GMO_VERSION         2256L
 #define MQRC_WRONG_MD_VERSION          2257L
 #define MQRC_GROUP_ID_ERROR            2258L
 #define MQRC_INCONSISTENT_BROWSE       2259L
 #define MQRC_XQH_ERROR                 2260L
 #define MQRC_SRC_ENV_ERROR             2261L
 #define MQRC_SRC_NAME_ERROR            2262L
 #define MQRC_DEST_ENV_ERROR            2263L
 #define MQRC_DEST_NAME_ERROR           2264L
 #define MQRC_TM_ERROR                  2265L
 #define MQRC_CLUSTER_EXIT_ERROR        2266L
 #define MQRC_CLUSTER_EXIT_LOAD_ERROR   2267L
 #define MQRC_CLUSTER_PUT_INHIBITED     2268L
 #define MQRC_CLUSTER_RESOURCE_ERROR    2269L
 #define MQRC_NO_DESTINATIONS_AVAILABLE 2270L
 #define MQRC_CONN_TAG_IN_USE           2271L
 #define MQRC_PARTIALLY_CONVERTED       2272L
 #define MQRC_CONNECTION_ERROR          2273L
 #define MQRC_OPTION_ENVIRONMENT_ERROR  2274L
 #define MQRC_CD_ERROR                  2277L
 #define MQRC_CLIENT_CONN_ERROR         2278L
 #define MQRC_CHANNEL_STOPPED_BY_USER   2279L
 #define MQRC_HCONFIG_ERROR             2280L
 #define MQRC_FUNCTION_ERROR            2281L
 #define MQRC_CHANNEL_STARTED           2282L
 #define MQRC_CHANNEL_STOPPED           2283L
 #define MQRC_CHANNEL_CONV_ERROR        2284L
 #define MQRC_SERVICE_NOT_AVAILABLE     2285L
 #define MQRC_INITIALIZATION_FAILED     2286L
 #define MQRC_TERMINATION_FAILED        2287L
 #define MQRC_UNKNOWN_Q_NAME            2288L
 #define MQRC_SERVICE_ERROR             2289L
 #define MQRC_Q_ALREADY_EXISTS          2290L
 #define MQRC_USER_ID_NOT_AVAILABLE     2291L
 #define MQRC_UNKNOWN_ENTITY            2292L
 #define MQRC_UNKNOWN_AUTH_ENTITY       2293L
 #define MQRC_UNKNOWN_REF_OBJECT        2294L
 #define MQRC_CHANNEL_ACTIVATED         2295L
 #define MQRC_CHANNEL_NOT_ACTIVATED     2296L
 #define MQRC_UOW_CANCELED              2297L
 #define MQRC_FUNCTION_NOT_SUPPORTED    2298L
 #define MQRC_SELECTOR_TYPE_ERROR       2299L
 #define MQRC_COMMAND_TYPE_ERROR        2300L
 #define MQRC_MULTIPLE_INSTANCE_ERROR   2301L
 #define MQRC_SYSTEM_ITEM_NOT_ALTERABLE 2302L
 #define MQRC_BAG_CONVERSION_ERROR      2303L
 #define MQRC_SELECTOR_OUT_OF_RANGE     2304L
 #define MQRC_SELECTOR_NOT_UNIQUE       2305L
 #define MQRC_INDEX_NOT_PRESENT         2306L
 #define MQRC_STRING_ERROR              2307L
 #define MQRC_ENCODING_NOT_SUPPORTED    2308L
 #define MQRC_SELECTOR_NOT_PRESENT      2309L
 #define MQRC_OUT_SELECTOR_ERROR        2310L
 #define MQRC_STRING_TRUNCATED          2311L
 #define MQRC_SELECTOR_WRONG_TYPE       2312L
 #define MQRC_INCONSISTENT_ITEM_TYPE    2313L
 #define MQRC_INDEX_ERROR               2314L
 #define MQRC_SYSTEM_BAG_NOT_ALTERABLE  2315L
 #define MQRC_ITEM_COUNT_ERROR          2316L
 #define MQRC_FORMAT_NOT_SUPPORTED      2317L
 #define MQRC_SELECTOR_NOT_SUPPORTED    2318L
 #define MQRC_ITEM_VALUE_ERROR          2319L
 #define MQRC_HBAG_ERROR                2320L
 #define MQRC_PARAMETER_MISSING         2321L
 #define MQRC_CMD_SERVER_NOT_AVAILABLE  2322L
 #define MQRC_STRING_LENGTH_ERROR       2323L
 #define MQRC_INQUIRY_COMMAND_ERROR     2324L
 #define MQRC_NESTED_BAG_NOT_SUPPORTED  2325L
 #define MQRC_BAG_WRONG_TYPE            2326L
 #define MQRC_ITEM_TYPE_ERROR           2327L
 #define MQRC_SYSTEM_BAG_NOT_DELETABLE  2328L
 #define MQRC_SYSTEM_ITEM_NOT_DELETABLE 2329L
 #define MQRC_CODED_CHAR_SET_ID_ERROR   2330L
 #define MQRC_MSG_TOKEN_ERROR           2331L
 #define MQRC_MISSING_WIH               2332L
 #define MQRC_WIH_ERROR                 2333L
 #define MQRC_RFH_ERROR                 2334L
 #define MQRC_RFH_STRING_ERROR          2335L
 #define MQRC_RFH_COMMAND_ERROR         2336L
 #define MQRC_RFH_PARM_ERROR            2337L
 #define MQRC_RFH_DUPLICATE_PARM        2338L
 #define MQRC_RFH_PARM_MISSING          2339L
 #define MQRC_CHAR_CONVERSION_ERROR     2340L
 #define MQRC_UCS2_CONVERSION_ERROR     2341L
 #define MQRC_DB2_NOT_AVAILABLE         2342L
 #define MQRC_OBJECT_NOT_UNIQUE         2343L
 #define MQRC_CONN_TAG_NOT_RELEASED     2344L
 #define MQRC_CF_NOT_AVAILABLE          2345L
 #define MQRC_CF_STRUC_IN_USE           2346L
 #define MQRC_CF_STRUC_LIST_HDR_IN_USE  2347L
 #define MQRC_CF_STRUC_AUTH_FAILED      2348L
 #define MQRC_CF_STRUC_ERROR            2349L
 #define MQRC_CONN_TAG_NOT_USABLE       2350L
 #define MQRC_GLOBAL_UOW_CONFLICT       2351L
 #define MQRC_LOCAL_UOW_CONFLICT        2352L
 #define MQRC_HANDLE_IN_USE_FOR_UOW     2353L
 #define MQRC_UOW_ENLISTMENT_ERROR      2354L
 #define MQRC_UOW_MIX_NOT_SUPPORTED     2355L
 #define MQRC_WXP_ERROR                 2356L
 #define MQRC_CURRENT_RECORD_ERROR      2357L
 #define MQRC_NEXT_OFFSET_ERROR         2358L
 #define MQRC_NO_RECORD_AVAILABLE       2359L
 #define MQRC_OBJECT_LEVEL_INCOMPATIBLE 2360L
 #define MQRC_NEXT_RECORD_ERROR         2361L
 #define MQRC_API_EXIT_ERROR            2374
 #define MQRC_API_EXIT_INIT_ERROR       2375
 #define MQRC_API_EXIT_TERM_ERROR       2376
 #define MQRC_EXIT_REASON_ERROR         2377
 #define MQRC_RESERVED_VALUE_ERROR      2378
 #define MQRC_APPL_FIRST                900L
 #define MQRC_APPL_LAST                 999L


 /*********************************************************************/
 /*  Values Related to Queue Attributes                               */
 /*********************************************************************/

 /* Queue Types */
 #define MQQT_LOCAL     1L
 #define MQQT_MODEL     2L
 #define MQQT_ALIAS     3L
 #define MQQT_REMOTE    6L
 #define MQQT_CLUSTER   7L

 /* Cluster Queue Types */
 #define MQCQT_LOCAL_Q     1L
 #define MQCQT_ALIAS_Q     2L
 #define MQCQT_REMOTE_Q    3L
 #define MQCQT_Q_MGR_ALIAS 4L

 /* Extended Queue Types */
 #define MQQT_ALL 1001L

 /* Queue Definition Types */
 #define MQQDT_PREDEFINED        1L
 #define MQQDT_PERMANENT_DYNAMIC 2L
 #define MQQDT_TEMPORARY_DYNAMIC 3L
 #define MQQDT_SHARED_DYNAMIC    4L

 /* Inhibit Get */
 #define MQQA_GET_INHIBITED 1L
 #define MQQA_GET_ALLOWED   0L

 /* Inhibit Put */
 #define MQQA_PUT_INHIBITED 1L
 #define MQQA_PUT_ALLOWED   0L

 /* Queue Shareability */
 #define MQQA_SHAREABLE     1L
 #define MQQA_NOT_SHAREABLE 0L

 /* Back-Out Hardening */
 #define MQQA_BACKOUT_HARDENED     1L
 #define MQQA_BACKOUT_NOT_HARDENED 0L

 /* Message Delivery Sequence */
 #define MQMDS_PRIORITY 0L
 #define MQMDS_FIFO     1L

 /* Trigger Control */
 #define MQTC_OFF 0L
 #define MQTC_ON  1L

 /* Trigger Types */
 #define MQTT_NONE  0L
 #define MQTT_FIRST 1L
 #define MQTT_EVERY 2L
 #define MQTT_DEPTH 3L

 /* Queue Usage */
 #define MQUS_NORMAL       0L
 #define MQUS_TRANSMISSION 1L

 /* Distribution Lists */
 #define MQDL_SUPPORTED     1L
 #define MQDL_NOT_SUPPORTED 0L

 /* Index Type */
 #define MQIT_NONE      0L
 #define MQIT_MSG_ID    1L
 #define MQIT_CORREL_ID 2L
 #define MQIT_MSG_TOKEN 4L

 /* Default Bind */
 #define MQBND_BIND_ON_OPEN   0L
 #define MQBND_BIND_NOT_FIXED 1L

 /* Queue Sharing Group Disposition */
 #define MQQSGD_Q_MGR  0L
 #define MQQSGD_COPY   1L
 #define MQQSGD_SHARED 2L

 /*********************************************************************/
 /*  Values Related to Namelist Attributes                            */
 /*********************************************************************/

 /* Name Count */
 #define MQNC_MAX_NAMELIST_NAME_COUNT 256L


 /*********************************************************************/
 /*  Values Related to Process-Definition Attributes                  */
 /*********************************************************************/

 /* Application Types */
 /* See values for "Put Application Types" under MQMD */


 /*********************************************************************/
 /*  Values Related to Queue-Manager Attributes                       */
 /*********************************************************************/

 /* Command Level */
 #define MQCMDL_LEVEL_1   100L
 #define MQCMDL_LEVEL_101 101L
 #define MQCMDL_LEVEL_110 110L
 #define MQCMDL_LEVEL_114 114L
 #define MQCMDL_LEVEL_120 120L
 #define MQCMDL_LEVEL_200 200L
 #define MQCMDL_LEVEL_201 201L
 #define MQCMDL_LEVEL_210 210L
 #define MQCMDL_LEVEL_220 220L
 #define MQCMDL_LEVEL_221 221L
 #define MQCMDL_LEVEL_320 320L
 #define MQCMDL_LEVEL_420 420L
 #define MQCMDL_LEVEL_500 500L
 #define MQCMDL_LEVEL_510 510L
 #define MQCMDL_LEVEL_520 520L

 /* Platform */
 #define MQPL_MVS        1L
 #define MQPL_OS390      1L
 #define MQPL_OS2        2L
 #define MQPL_AIX        3L
 #define MQPL_UNIX       3L
 #define MQPL_OS400      4L
 #define MQPL_WINDOWS    5L
 #define MQPL_WINDOWS_NT 11L
 #define MQPL_VMS        12L
 #define MQPL_NSK        13L

 /* Syncpoint Availability */
 #define MQSP_AVAILABLE     1L
 #define MQSP_NOT_AVAILABLE 0L

 /* Channel Auto Definition */
 #define MQCHAD_DISABLED 0L
 #define MQCHAD_ENABLED  1L

 /* Intra-Group Queuing */
 #define MQIGQ_DISABLED 0L
 #define MQIGQ_ENABLED  1L

 /* Intra-Group Queuing Put Authority */
 #define MQIGQPA_DEFAULT          1L
 #define MQIGQPA_CONTEXT          2L
 #define MQIGQPA_ONLY_IGQ         3L
 #define MQIGQPA_ALTERNATE_OR_IGQ 4L

 /* Distribution Lists */
 /* See values for "Distribution Lists" under Queue Attributes */


 /*********************************************************************/
 /*  Simple Data Types                                                */
 /*********************************************************************/

 /* Byte Datatypes */
 typedef unsigned char MQBYTE;
 typedef MQBYTE MQPOINTER PMQBYTE;
 typedef MQBYTE MQBYTE8[8];
 typedef MQBYTE8 MQPOINTER PMQBYTE8;
 typedef MQBYTE MQBYTE16[16];
 typedef MQBYTE16 MQPOINTER PMQBYTE16;
 typedef MQBYTE MQBYTE24[24];
 typedef MQBYTE24 MQPOINTER PMQBYTE24;
 typedef MQBYTE MQBYTE32[32];
 typedef MQBYTE32 MQPOINTER PMQBYTE32;
 typedef MQBYTE MQBYTE40[40];
 typedef MQBYTE40 MQPOINTER PMQBYTE40;
 typedef MQBYTE MQBYTE128[128];
 typedef MQBYTE128 MQPOINTER PMQBYTE128;

 /* Character Datatypes */
 typedef char MQCHAR;
 typedef MQCHAR MQPOINTER PMQCHAR;
 typedef MQCHAR MQCHAR4[4];
 typedef MQCHAR4 MQPOINTER PMQCHAR4;
 typedef MQCHAR MQCHAR8[8];
 typedef MQCHAR8 MQPOINTER PMQCHAR8;
 typedef MQCHAR MQCHAR12[12];
 typedef MQCHAR12 MQPOINTER PMQCHAR12;
 typedef MQCHAR MQCHAR16[16];
 typedef MQCHAR16 MQPOINTER PMQCHAR16;
 typedef MQCHAR MQCHAR20[20];
 typedef MQCHAR20 MQPOINTER PMQCHAR20;
 typedef MQCHAR MQCHAR28[28];
 typedef MQCHAR28 MQPOINTER PMQCHAR28;
 typedef MQCHAR MQCHAR32[32];
 typedef MQCHAR32 MQPOINTER PMQCHAR32;
 typedef MQCHAR MQCHAR48[48];
 typedef MQCHAR48 MQPOINTER PMQCHAR48;
 typedef MQCHAR MQCHAR64[64];
 typedef MQCHAR64 MQPOINTER PMQCHAR64;
 typedef MQCHAR MQCHAR128[128];
 typedef MQCHAR128 MQPOINTER PMQCHAR128;
 typedef MQCHAR MQCHAR256[256];
 typedef MQCHAR256 MQPOINTER PMQCHAR256;

 /* Other Datatypes */
#if defined(MQ_64_BIT)
 typedef int MQLONG;
 typedef unsigned int MQULONG;
#else
 typedef long MQLONG;
 typedef unsigned long MQULONG;
#endif
 typedef MQLONG MQPOINTER PMQLONG;
 typedef MQULONG MQPOINTER PMQULONG;
 typedef MQLONG MQHCONN;
 typedef MQHCONN MQPOINTER PMQHCONN;
 typedef PMQHCONN MQPOINTER PPMQHCONN;
 typedef MQLONG MQHOBJ;
 typedef MQHOBJ MQPOINTER PMQHOBJ;
 typedef void MQPOINTER MQPTR;
 typedef MQPTR MQPOINTER PMQPTR;
 typedef void MQPOINTER PMQVOID;
 typedef PMQVOID MQPOINTER PPMQVOID;
 typedef void MQPOINTER MQHCONFIG;
 typedef MQHCONFIG MQPOINTER PMQHCONFIG;
 typedef void MQPOINTER PMQFUNC;
 typedef PMQLONG MQPOINTER PPMQLONG;
 typedef PMQBYTE MQPOINTER PPMQBYTE;
 typedef PMQHOBJ MQPOINTER PPMQHOBJ;
 typedef PMQCHAR MQPOINTER PPMQCHAR;
 typedef MQLONG MQPID;
 typedef MQLONG MQTID;


 /*********************************************************************/
 /*  MQBO Structure -- Begin Options                                  */
 /*********************************************************************/

 typedef struct tagMQBO {
   MQCHAR4  StrucId;  /* Structure identifier */
   MQLONG   Version;  /* Structure version number */
   MQLONG   Options;  /* Options that control the action of MQBEGIN */
 } MQBO;
 typedef MQBO MQPOINTER PMQBO;
 typedef PMQBO MQPOINTER PPMQBO;

 #define MQBO_DEFAULT {MQBO_STRUC_ID_ARRAY},\
                      MQBO_VERSION_1,\
                      MQBO_NONE


 /*********************************************************************/
 /*  MQCIH Structure -- CICS Information Header                       */
 /*********************************************************************/

 typedef struct tagMQCIH {
   MQCHAR4  StrucId;             /* Structure identifier */
   MQLONG   Version;             /* Structure version number */
   MQLONG   StrucLength;         /* Length of MQCIH structure */
   MQLONG   Encoding;            /* Reserved */
   MQLONG   CodedCharSetId;      /* Reserved */
   MQCHAR8  Format;              /* MQ format name of data that follows
                                    MQCIH */
   MQLONG   Flags;               /* Flags */
   MQLONG   ReturnCode;          /* Return code from bridge */
   MQLONG   CompCode;            /* MQ completion code or CICS
                                    EIBRESP */
   MQLONG   Reason;              /* MQ reason or feedback code, or CICS
                                    EIBRESP2 */
   MQLONG   UOWControl;          /* Unit-of-work control */
   MQLONG   GetWaitInterval;     /* Wait interval for MQGET call issued
                                    by bridge task */
   MQLONG   LinkType;            /* Link type */
   MQLONG   OutputDataLength;    /* Output COMMAREA data length */
   MQLONG   FacilityKeepTime;    /* Bridge facility release time */
   MQLONG   ADSDescriptor;       /* Send/receive ADS descriptor */
   MQLONG   ConversationalTask;  /* Whether task can be
                                    conversational */
   MQLONG   TaskEndStatus;       /* Status at end of task */
   MQBYTE8  Facility;            /* Bridge facility token */
   MQCHAR4  Function;            /* MQ call name or CICS EIBFN
                                    function */
   MQCHAR4  AbendCode;           /* Abend code */
   MQCHAR8  Authenticator;       /* Password or passticket */
   MQCHAR8  Reserved1;           /* Reserved */
   MQCHAR8  ReplyToFormat;       /* MQ format name of reply message */
   MQCHAR4  RemoteSysId;         /* Reserved */
   MQCHAR4  RemoteTransId;       /* Reserved */
   MQCHAR4  TransactionId;       /* Transaction to attach */
   MQCHAR4  FacilityLike;        /* Terminal emulated attributes */
   MQCHAR4  AttentionId;         /* AID key */
   MQCHAR4  StartCode;           /* Transaction start code */
   MQCHAR4  CancelCode;          /* Abend transaction code */
   MQCHAR4  NextTransactionId;   /* Next transaction to attach */
   MQCHAR8  Reserved2;           /* Reserved */
   MQCHAR8  Reserved3;           /* Reserved */
   MQLONG   CursorPosition;      /* Cursor position */
   MQLONG   ErrorOffset;         /* Offset of error in message */
   MQLONG   InputItem;           /* Reserved */
   MQLONG   Reserved4;           /* Reserved */
 } MQCIH;
 typedef MQCIH MQPOINTER PMQCIH;

 #define MQCIH_DEFAULT {MQCIH_STRUC_ID_ARRAY},\
                       MQCIH_VERSION_2,\
                       MQCIH_LENGTH_2,\
                       0L,\
                       0L,\
                       {MQFMT_NONE_ARRAY},\
                       MQCIH_NONE,\
                       MQCRC_OK,\
                       MQCC_OK,\
                       MQRC_NONE,\
                       MQCUOWC_ONLY,\
                       MQCGWI_DEFAULT,\
                       MQCLT_PROGRAM,\
                       MQCODL_AS_INPUT,\
                       0L,\
                       MQCADSD_NONE,\
                       MQCCT_NO,\
                       MQCTES_NOSYNC,\
                       {MQCFAC_NONE_ARRAY},\
                       {MQCFUNC_NONE_ARRAY},\
                       {' ',' ',' ',' '},\
                       {' ',' ',' ',' ',' ',' ',' ',' '},\
                       {' ',' ',' ',' ',' ',' ',' ',' '},\
                       {MQFMT_NONE_ARRAY},\
                       {' ',' ',' ',' '},\
                       {' ',' ',' ',' '},\
                       {' ',' ',' ',' '},\
                       {' ',' ',' ',' '},\
                       {' ',' ',' ',' '},\
                       {MQCSC_NONE_ARRAY},\
                       {' ',' ',' ',' '},\
                       {' ',' ',' ',' '},\
                       {' ',' ',' ',' ',' ',' ',' ',' '},\
                       {' ',' ',' ',' ',' ',' ',' ',' '},\
                       0L,\
                       0L,\
                       0L,\
                       0L


 /*********************************************************************/
 /*  MQCNO Structure -- Connect Options                               */
 /*********************************************************************/

 typedef struct tagMQCNO {
   MQCHAR4  StrucId;           /* Structure identifier */
   MQLONG   Version;           /* Structure version number */
   MQLONG   Options;           /* Options that control the action of
                                  MQCONNX */
   MQLONG   ClientConnOffset;  /* Offset of MQCD structure for client
                                  connection */
   MQPTR    ClientConnPtr;     /* Address of MQCD structure for client
                                  connection */
 } MQCNO;
 typedef MQCNO MQPOINTER PMQCNO;
 typedef PMQCNO MQPOINTER PPMQCNO;

 #define MQCNO_DEFAULT {MQCNO_STRUC_ID_ARRAY},\
                       MQCNO_VERSION_1,\
                       MQCNO_NONE,\
                       0L,\
                       NULL


 /*********************************************************************/
 /*  MQDH Structure -- Distribution Header                            */
 /*********************************************************************/

 typedef struct tagMQDH {
   MQCHAR4  StrucId;          /* Structure identifier */
   MQLONG   Version;          /* Structure version number */
   MQLONG   StrucLength;      /* Length of MQDH structure plus following
                                 records */
   MQLONG   Encoding;         /* Numeric encoding of data that follows
                                 array of MQPMR records */
   MQLONG   CodedCharSetId;   /* Character set identifier of data that
                                 follows array of MQPMR records */
   MQCHAR8  Format;           /* Format name of data that follows array
                                 of MQPMR records */
   MQLONG   Flags;            /* General flags */
   MQLONG   PutMsgRecFields;  /* Flags indicating which MQPMR fields are
                                 present */
   MQLONG   RecsPresent;      /* Number of object records present */
   MQLONG   ObjectRecOffset;  /* Offset of first object record from
                                 start of MQDH */
   MQLONG   PutMsgRecOffset;  /* Offset of first put message record from
                                 start of MQDH */
 } MQDH;
 typedef MQDH MQPOINTER PMQDH;

 #define MQDH_DEFAULT {MQDH_STRUC_ID_ARRAY},\
                      MQDH_VERSION_1,\
                      0L,\
                      0L,\
                      MQCCSI_UNDEFINED,\
                      {MQFMT_NONE_ARRAY},\
                      MQDHF_NONE,\
                      MQPMRF_NONE,\
                      0L,\
                      0L,\
                      0L


 /*********************************************************************/
 /*  MQDLH Structure -- Dead Letter Header                            */
 /*********************************************************************/

 typedef struct tagMQDLH {
   MQCHAR4   StrucId;         /* Structure identifier */
   MQLONG    Version;         /* Structure version number */
   MQLONG    Reason;          /* Reason message arrived on dead-letter
                                 (undelivered-message) queue */
   MQCHAR48  DestQName;       /* Name of original destination queue */
   MQCHAR48  DestQMgrName;    /* Name of original destination queue
                                 manager */
   MQLONG    Encoding;        /* Numeric encoding of data that follows
                                 MQDLH */
   MQLONG    CodedCharSetId;  /* Character set identifier of data that
                                 follows MQDLH */
   MQCHAR8   Format;          /* Format name of data that follows
                                 MQDLH */
   MQLONG    PutApplType;     /* Type of application that put message on
                                 dead-letter (undelivered-message)
                                 queue */
   MQCHAR28  PutApplName;     /* Name of application that put message on
                                 dead-letter (undelivered-message)
                                 queue */
   MQCHAR8   PutDate;         /* Date when message was put on
                                 dead-letter (undelivered-message)
                                 queue */
   MQCHAR8   PutTime;         /* Time when message was put on the
                                 dead-letter (undelivered-message)
                                 queue */
 } MQDLH;
 typedef MQDLH MQPOINTER PMQDLH;

 #define MQDLH_DEFAULT {MQDLH_STRUC_ID_ARRAY},\
                       MQDLH_VERSION_1,\
                       MQRC_NONE,\
                       {""},\
                       {""},\
                       0L,\
                       MQCCSI_UNDEFINED,\
                       {MQFMT_NONE_ARRAY},\
                       0L,\
                       {""},\
                       {""},\
                       {""}


 /*********************************************************************/
 /*  MQGMO Structure -- Get Message Options                           */
 /*********************************************************************/

 typedef struct tagMQGMO {
   MQCHAR4   StrucId;         /* Structure identifier */
   MQLONG    Version;         /* Structure version number */
   MQLONG    Options;         /* Options that control the action of
                                 MQGET */
   MQLONG    WaitInterval;    /* Wait interval */
   MQLONG    Signal1;         /* Signal */
   MQLONG    Signal2;         /* Signal identifier */
   MQCHAR48  ResolvedQName;   /* Resolved name of destination queue */
   MQLONG    MatchOptions;    /* Options controlling selection criteria
                                 used for MQGET */
   MQCHAR    GroupStatus;     /* Flag indicating whether message
                                 retrieved is in a group */
   MQCHAR    SegmentStatus;   /* Flag indicating whether message
                                 retrieved is a segment of a logical
                                 message */
   MQCHAR    Segmentation;    /* Flag indicating whether further
                                 segmentation is allowed for the message
                                 retrieved */
   MQCHAR    Reserved1;       /* Reserved */
   MQBYTE16  MsgToken;        /* Message token */
   MQLONG    ReturnedLength;  /* Length of message data returned
                                 (bytes) */
 } MQGMO;
 typedef MQGMO MQPOINTER PMQGMO;
 typedef PMQGMO MQPOINTER PPMQGMO;

 #define MQGMO_DEFAULT {MQGMO_STRUC_ID_ARRAY},\
                       MQGMO_VERSION_1,\
                       MQGMO_NO_WAIT,\
                       0L,\
                       0L,\
                       0L,\
                       {""},\
                       (MQMO_MATCH_MSG_ID+MQMO_MATCH_CORREL_ID),\
                       MQGS_NOT_IN_GROUP,\
                       MQSS_NOT_A_SEGMENT,\
                       MQSEG_INHIBITED,\
                       ' ',\
                       {MQMTOK_NONE_ARRAY},\
                       MQRL_UNDEFINED


 /*********************************************************************/
 /*  MQIIH Structure -- IMS Information Header                        */
 /*********************************************************************/

 typedef struct tagMQIIH {
   MQCHAR4   StrucId;         /* Structure identifier */
   MQLONG    Version;         /* Structure version number */
   MQLONG    StrucLength;     /* Length of MQIIH structure */
   MQLONG    Encoding;        /* Reserved */
   MQLONG    CodedCharSetId;  /* Reserved */
   MQCHAR8   Format;          /* MQ format name of data that follows
                                 MQIIH */
   MQLONG    Flags;           /* Flags */
   MQCHAR8   LTermOverride;   /* Logical terminal override */
   MQCHAR8   MFSMapName;      /* Message format services map name */
   MQCHAR8   ReplyToFormat;   /* MQ format name of reply message */
   MQCHAR8   Authenticator;   /* RACF password or passticket */
   MQBYTE16  TranInstanceId;  /* Transaction instance identifier */
   MQCHAR    TranState;       /* Transaction state */
   MQCHAR    CommitMode;      /* Commit mode */
   MQCHAR    SecurityScope;   /* Security scope */
   MQCHAR    Reserved;        /* Reserved */
 } MQIIH;
 typedef MQIIH MQPOINTER PMQIIH;

 #define MQIIH_DEFAULT {MQIIH_STRUC_ID_ARRAY},\
                       MQIIH_VERSION_1,\
                       MQIIH_LENGTH_1,\
                       0L,\
                       0L,\
                       {MQFMT_NONE_ARRAY},\
                       MQIIH_NONE,\
                       {' ',' ',' ',' ',' ',' ',' ',' '},\
                       {' ',' ',' ',' ',' ',' ',' ',' '},\
                       {MQFMT_NONE_ARRAY},\
                       {MQIAUT_NONE_ARRAY},\
                       {MQITII_NONE_ARRAY},\
                       MQITS_NOT_IN_CONVERSATION,\
                       MQICM_COMMIT_THEN_SEND,\
                       MQISS_CHECK,\
                       ' '


 /*********************************************************************/
 /*  MQMD Structure -- Message Descriptor                             */
 /*********************************************************************/

 typedef struct tagMQMD {
   MQCHAR4   StrucId;           /* Structure identifier */
   MQLONG    Version;           /* Structure version number */
   MQLONG    Report;            /* Options for report messages */
   MQLONG    MsgType;           /* Message type */
   MQLONG    Expiry;            /* Message lifetime */
   MQLONG    Feedback;          /* Feedback or reason code */
   MQLONG    Encoding;          /* Numeric encoding of message data */
   MQLONG    CodedCharSetId;    /* Character set identifier of message
                                   data */
   MQCHAR8   Format;            /* Format name of message data */
   MQLONG    Priority;          /* Message priority */
   MQLONG    Persistence;       /* Message persistence */
   MQBYTE24  MsgId;             /* Message identifier */
   MQBYTE24  CorrelId;          /* Correlation identifier */
   MQLONG    BackoutCount;      /* Backout counter */
   MQCHAR48  ReplyToQ;          /* Name of reply queue */
   MQCHAR48  ReplyToQMgr;       /* Name of reply queue manager */
   MQCHAR12  UserIdentifier;    /* User identifier */
   MQBYTE32  AccountingToken;   /* Accounting token */
   MQCHAR32  ApplIdentityData;  /* Application data relating to
                                   identity */
   MQLONG    PutApplType;       /* Type of application that put the
                                   message */
   MQCHAR28  PutApplName;       /* Name of application that put the
                                   message */
   MQCHAR8   PutDate;           /* Date when message was put */
   MQCHAR8   PutTime;           /* Time when message was put */
   MQCHAR4   ApplOriginData;    /* Application data relating to
                                   origin */
   MQBYTE24  GroupId;           /* Group identifier */
   MQLONG    MsgSeqNumber;      /* Sequence number of logical message
                                   within group */
   MQLONG    Offset;            /* Offset of data in physical message
                                   from start of logical message */
   MQLONG    MsgFlags;          /* Message flags */
   MQLONG    OriginalLength;    /* Length of original message */
 } MQMD;
 typedef MQMD MQPOINTER PMQMD;
 typedef PMQMD MQPOINTER PPMQMD;

 #define MQMD_DEFAULT {MQMD_STRUC_ID_ARRAY},\
                      MQMD_VERSION_1,\
                      MQRO_NONE,\
                      MQMT_DATAGRAM,\
                      MQEI_UNLIMITED,\
                      MQFB_NONE,\
                      MQENC_NATIVE,\
                      MQCCSI_Q_MGR,\
                      {MQFMT_NONE_ARRAY},\
                      MQPRI_PRIORITY_AS_Q_DEF,\
                      MQPER_PERSISTENCE_AS_Q_DEF,\
                      {MQMI_NONE_ARRAY},\
                      {MQCI_NONE_ARRAY},\
                      0L,\
                      {""},\
                      {""},\
                      {""},\
                      {MQACT_NONE_ARRAY},\
                      {""},\
                      MQAT_NO_CONTEXT,\
                      {""},\
                      {""},\
                      {""},\
                      {""},\
                      {MQGI_NONE_ARRAY},\
                      1L,\
                      0L,\
                      MQMF_NONE,\
                      MQOL_UNDEFINED


 /*********************************************************************/
 /*  MQMDE Structure -- Message Descriptor Extension                  */
 /*********************************************************************/

 typedef struct tagMQMDE {
   MQCHAR4   StrucId;         /* Structure identifier */
   MQLONG    Version;         /* Structure version number */
   MQLONG    StrucLength;     /* Length of MQMDE structure */
   MQLONG    Encoding;        /* Numeric encoding of data that follows
                                 MQMDE */
   MQLONG    CodedCharSetId;  /* Character-set identifier of data that
                                 follows MQMDE */
   MQCHAR8   Format;          /* Format name of data that follows
                                 MQMDE */
   MQLONG    Flags;           /* General flags */
   MQBYTE24  GroupId;         /* Group identifier */
   MQLONG    MsgSeqNumber;    /* Sequence number of logical message
                                 within group */
   MQLONG    Offset;          /* Offset of data in physical message from
                                 start of logical message */
   MQLONG    MsgFlags;        /* Message flags */
   MQLONG    OriginalLength;  /* Length of original message */
 } MQMDE;
 typedef MQMDE MQPOINTER PMQMDE;

 #define MQMDE_DEFAULT {MQMDE_STRUC_ID_ARRAY},\
                       MQMDE_VERSION_2,\
                       MQMDE_LENGTH_2,\
                       MQENC_NATIVE,\
                       MQCCSI_UNDEFINED,\
                       {MQFMT_NONE_ARRAY},\
                       MQMDEF_NONE,\
                       {MQGI_NONE_ARRAY},\
                       1L,\
                       0L,\
                       MQMF_NONE,\
                       MQOL_UNDEFINED


 /*********************************************************************/
 /*  MQMD1 Structure -- Version-1 Message Descriptor                  */
 /*********************************************************************/

 typedef struct tagMQMD1 {
   MQCHAR4   StrucId;           /* Structure identifier */
   MQLONG    Version;           /* Structure version number */
   MQLONG    Report;            /* Report options */
   MQLONG    MsgType;           /* Message type */
   MQLONG    Expiry;            /* Expiry time */
   MQLONG    Feedback;          /* Feedback or reason code */
   MQLONG    Encoding;          /* Numeric encoding of message data */
   MQLONG    CodedCharSetId;    /* Character set identifier of message
                                   data */
   MQCHAR8   Format;            /* Format name of message data */
   MQLONG    Priority;          /* Message priority */
   MQLONG    Persistence;       /* Message persistence */
   MQBYTE24  MsgId;             /* Message identifier */
   MQBYTE24  CorrelId;          /* Correlation identifier */
   MQLONG    BackoutCount;      /* Backout counter */
   MQCHAR48  ReplyToQ;          /* Name of reply-to queue */
   MQCHAR48  ReplyToQMgr;       /* Name of reply queue manager */
   MQCHAR12  UserIdentifier;    /* User identifier */
   MQBYTE32  AccountingToken;   /* Accounting token */
   MQCHAR32  ApplIdentityData;  /* Application data relating to
                                   identity */
   MQLONG    PutApplType;       /* Type of application that put the
                                   message */
   MQCHAR28  PutApplName;       /* Name of application that put the
                                   message */
   MQCHAR8   PutDate;           /* Date when message was put */
   MQCHAR8   PutTime;           /* Time when message was put */
   MQCHAR4   ApplOriginData;    /* Application data relating to
                                   origin */
 } MQMD1;
 typedef MQMD1 MQPOINTER PMQMD1;

 #define MQMD1_DEFAULT {MQMD_STRUC_ID_ARRAY},\
                       MQMD_VERSION_1,\
                       MQRO_NONE,\
                       MQMT_DATAGRAM,\
                       MQEI_UNLIMITED,\
                       MQFB_NONE,\
                       MQENC_NATIVE,\
                       MQCCSI_Q_MGR,\
                       {MQFMT_NONE_ARRAY},\
                       MQPRI_PRIORITY_AS_Q_DEF,\
                       MQPER_PERSISTENCE_AS_Q_DEF,\
                       {MQMI_NONE_ARRAY},\
                       {MQCI_NONE_ARRAY},\
                       0L,\
                       {""},\
                       {""},\
                       {""},\
                       {MQACT_NONE_ARRAY},\
                       {""},\
                       MQAT_NO_CONTEXT,\
                       {""},\
                       {""},\
                       {""},\
                       {""}


 /*********************************************************************/
 /*  MQOD Structure -- Object Descriptor                              */
 /*********************************************************************/

 typedef struct tagMQOD {
   MQCHAR4   StrucId;              /* Structure identifier */
   MQLONG    Version;              /* Structure version number */
   MQLONG    ObjectType;           /* Object type */
   MQCHAR48  ObjectName;           /* Object name */
   MQCHAR48  ObjectQMgrName;       /* Object queue manager name */
   MQCHAR48  DynamicQName;         /* Dynamic queue name */
   MQCHAR12  AlternateUserId;      /* Alternate user identifier */
   MQLONG    RecsPresent;          /* Number of object records
                                      present */
   MQLONG    KnownDestCount;       /* Number of local queues opened
                                      successfully */
   MQLONG    UnknownDestCount;     /* Number of remote queues opened
                                      successfully */
   MQLONG    InvalidDestCount;     /* Number of queues that failed to
                                      open */
   MQLONG    ObjectRecOffset;      /* Offset of first object record from
                                      start of MQOD */
   MQLONG    ResponseRecOffset;    /* Offset of first response record
                                      from start of MQOD */
   MQPTR     ObjectRecPtr;         /* Address of first object record */
   MQPTR     ResponseRecPtr;       /* Address of first response
                                      record */
   MQBYTE40  AlternateSecurityId;  /* Alternate security identifier */
   MQCHAR48  ResolvedQName;        /* Resolved queue name */
   MQCHAR48  ResolvedQMgrName;     /* Resolved queue manager name */
 } MQOD;
 typedef MQOD MQPOINTER PMQOD;
 typedef PMQOD MQPOINTER PPMQOD;

 #define MQOD_DEFAULT {MQOD_STRUC_ID_ARRAY},\
                      MQOD_VERSION_1,\
                      MQOT_Q,\
                      {""},\
                      {""},\
                      {"AMQ.*"},\
                      {""},\
                      0L,\
                      0L,\
                      0L,\
                      0L,\
                      0L,\
                      0L,\
                      NULL,\
                      NULL,\
                      {MQSID_NONE_ARRAY},\
                      {""},\
                      {""}


 /*********************************************************************/
 /*  MQOR Structure -- Object Record                                  */
 /*********************************************************************/

 typedef struct tagMQOR {
   MQCHAR48  ObjectName;      /* Object name */
   MQCHAR48  ObjectQMgrName;  /* Object queue manager name */
 } MQOR;
 typedef MQOR MQPOINTER PMQOR;

 #define MQOR_DEFAULT {""},\
                      {""}


 /*********************************************************************/
 /*  MQPMO Structure -- Put Message Options                           */
 /*********************************************************************/

 typedef struct tagMQPMO {
   MQCHAR4   StrucId;            /* Structure identifier */
   MQLONG    Version;            /* Structure version number */
   MQLONG    Options;            /* Options that control the action of
                                    MQPUT and MQPUT1 */
   MQLONG    Timeout;            /* Reserved */
   MQHOBJ    Context;            /* Object handle of input queue */
   MQLONG    KnownDestCount;     /* Number of messages sent successfully
                                    to local queues */
   MQLONG    UnknownDestCount;   /* Number of messages sent successfully
                                    to remote queues */
   MQLONG    InvalidDestCount;   /* Number of messages that could not be
                                    sent */
   MQCHAR48  ResolvedQName;      /* Resolved name of destination
                                    queue */
   MQCHAR48  ResolvedQMgrName;   /* Resolved name of destination queue
                                    manager */
   MQLONG    RecsPresent;        /* Number of put message records or
                                    response records present */
   MQLONG    PutMsgRecFields;    /* Flags indicating which MQPMR fields
                                    are present */
   MQLONG    PutMsgRecOffset;    /* Offset of first put message record
                                    from start of MQPMO */
   MQLONG    ResponseRecOffset;  /* Offset of first response record from
                                    start of MQPMO */
   MQPTR     PutMsgRecPtr;       /* Address of first put message
                                    record */
   MQPTR     ResponseRecPtr;     /* Address of first response record */
 } MQPMO;
 typedef MQPMO MQPOINTER PMQPMO;
 typedef PMQPMO MQPOINTER PPMQPMO;

 #define MQPMO_DEFAULT {MQPMO_STRUC_ID_ARRAY},\
                       MQPMO_VERSION_1,\
                       MQPMO_NONE,\
                       (-1L),\
                       0L,\
                       0L,\
                       0L,\
                       0L,\
                       {""},\
                       {""},\
                       0L,\
                       MQPMRF_NONE,\
                       0L,\
                       0L,\
                       NULL,\
                       NULL


 /*********************************************************************/
 /*  MQRFH Structure -- Rules and Formatting Header                   */
 /*********************************************************************/

 typedef struct tagMQRFH {
   MQCHAR4  StrucId;         /* Structure identifier */
   MQLONG   Version;         /* Structure version number */
   MQLONG   StrucLength;     /* Total length of MQRFH including string
                                containing name/value pairs */
   MQLONG   Encoding;        /* Numeric encoding of data that follows
                                NameValueString */
   MQLONG   CodedCharSetId;  /* Character set identifier of data that
                                follows NameValueString */
   MQCHAR8  Format;          /* Format name of data that follows
                                NameValueString */
   MQLONG   Flags;           /* Flags */
 } MQRFH;
 typedef MQRFH MQPOINTER PMQRFH;

 #define MQRFH_DEFAULT {MQRFH_STRUC_ID_ARRAY},\
                       MQRFH_VERSION_1,\
                       MQRFH_STRUC_LENGTH_FIXED,\
                       MQENC_NATIVE,\
                       MQCCSI_UNDEFINED,\
                       {MQFMT_NONE_ARRAY},\
                       MQRFH_NONE


 /*********************************************************************/
 /*  MQRFH2 Structure -- Rules and Formatting Header 2                */
 /*********************************************************************/

 typedef struct tagMQRFH2 {
   MQCHAR4  StrucId;         /* Structure identifier */
   MQLONG   Version;         /* Structure version number */
   MQLONG   StrucLength;     /* Total length of MQRFH2 including
                                NameValueData */
   MQLONG   Encoding;        /* Numeric encoding of data that follows
                                NameValueData */
   MQLONG   CodedCharSetId;  /* Character set identifier of data that
                                follows NameValueData */
   MQCHAR8  Format;          /* Format name of data that follows
                                NameValueData */
   MQLONG   Flags;           /* Flags */
   MQLONG   NameValueCCSID;  /* Character set identifier of
                                NameValueData */
 } MQRFH2;
 typedef MQRFH2 MQPOINTER PMQRFH2;

 #define MQRFH2_DEFAULT {MQRFH_STRUC_ID_ARRAY},\
                        MQRFH_VERSION_2,\
                        MQRFH_STRUC_LENGTH_FIXED_2,\
                        MQENC_NATIVE,\
                        MQCCSI_INHERIT,\
                        {MQFMT_NONE_ARRAY},\
                        MQRFH_NONE,\
                        1208L


 /*********************************************************************/
 /*  MQRMH Structure -- Reference Message Header                      */
 /*********************************************************************/

 typedef struct tagMQRMH {
   MQCHAR4   StrucId;             /* Structure identifier */
   MQLONG    Version;             /* Structure version number */
   MQLONG    StrucLength;         /* Total length of MQRMH, including
                                     strings at end of fixed fields, but
                                     not the bulk data */
   MQLONG    Encoding;            /* Numeric encoding of bulk data */
   MQLONG    CodedCharSetId;      /* Character set identifier of bulk
                                     data */
   MQCHAR8   Format;              /* Format name of bulk data */
   MQLONG    Flags;               /* Reference message flags */
   MQCHAR8   ObjectType;          /* Object type */
   MQBYTE24  ObjectInstanceId;    /* Object instance identifier */
   MQLONG    SrcEnvLength;        /* Length of source environment
                                     data */
   MQLONG    SrcEnvOffset;        /* Offset of source environment
                                     data */
   MQLONG    SrcNameLength;       /* Length of source object name */
   MQLONG    SrcNameOffset;       /* Offset of source object name */
   MQLONG    DestEnvLength;       /* Length of destination environment
                                     data */
   MQLONG    DestEnvOffset;       /* Offset of destination environment
                                     data */
   MQLONG    DestNameLength;      /* Length of destination object
                                     name */
   MQLONG    DestNameOffset;      /* Offset of destination object
                                     name */
   MQLONG    DataLogicalLength;   /* Length of bulk data */
   MQLONG    DataLogicalOffset;   /* Low offset of bulk data */
   MQLONG    DataLogicalOffset2;  /* High offset of bulk data */
 } MQRMH;
 typedef MQRMH MQPOINTER PMQRMH;

 #define MQRMH_DEFAULT {MQRMH_STRUC_ID_ARRAY},\
                       MQRMH_VERSION_1,\
                       0L,\
                       MQENC_NATIVE,\
                       MQCCSI_UNDEFINED,\
                       {MQFMT_NONE_ARRAY},\
                       MQRMHF_NOT_LAST,\
                       {' ',' ',' ',' ',' ',' ',' ',' '},\
                       {MQOII_NONE_ARRAY},\
                       0L,\
                       0L,\
                       0L,\
                       0L,\
                       0L,\
                       0L,\
                       0L,\
                       0L,\
                       0L,\
                       0L,\
                       0L


 /*********************************************************************/
 /*  MQRR Structure -- Response Record                                */
 /*********************************************************************/

 typedef struct tagMQRR {
   MQLONG  CompCode;  /* Completion code for queue */
   MQLONG  Reason;    /* Reason code for queue */
 } MQRR;
 typedef MQRR MQPOINTER PMQRR;

 #define MQRR_DEFAULT MQCC_OK,\
                      MQRC_NONE


 /*********************************************************************/
 /*  MQTM Structure -- Trigger Message                                */
 /*********************************************************************/

 typedef struct tagMQTM {
   MQCHAR4    StrucId;      /* Structure identifier */
   MQLONG     Version;      /* Structure version number */
   MQCHAR48   QName;        /* Name of triggered queue */
   MQCHAR48   ProcessName;  /* Name of process object */
   MQCHAR64   TriggerData;  /* Trigger data */
   MQLONG     ApplType;     /* Application type */
   MQCHAR256  ApplId;       /* Application identifier */
   MQCHAR128  EnvData;      /* Environment data */
   MQCHAR128  UserData;     /* User data */
 } MQTM;
 typedef MQTM MQPOINTER PMQTM;

 #define MQTM_DEFAULT {MQTM_STRUC_ID_ARRAY},\
                      MQTM_VERSION_1,\
                      {""},\
                      {""},\
                      {""},\
                      0L,\
                      {""},\
                      {""},\
                      {""}



 /*********************************************************************/
 /*  MQTMC2 Structure -- Trigger Message 2 (Character)                */
 /*********************************************************************/

 typedef struct tagMQTMC2 {
   MQCHAR4    StrucId;      /* Structure identifier */
   MQCHAR4    Version;      /* Structure version number */
   MQCHAR48   QName;        /* Name of triggered queue */
   MQCHAR48   ProcessName;  /* Name of process object */
   MQCHAR64   TriggerData;  /* Trigger data */
   MQCHAR4    ApplType;     /* Application type */
   MQCHAR256  ApplId;       /* Application identifier */
   MQCHAR128  EnvData;      /* Environment data */
   MQCHAR128  UserData;     /* User data */
   MQCHAR48   QMgrName;     /* Queue manager name */
 } MQTMC2;
 typedef MQTMC2 MQPOINTER PMQTMC2;

 #define MQTMC2_DEFAULT {MQTMC_STRUC_ID_ARRAY},\
                        {MQTMC_VERSION_2_ARRAY},\
                        {""},\
                        {""},\
                        {""},\
                        {""},\
                        {""},\
                        {""},\
                        {""},\
                        {""}


 /*********************************************************************/
 /*  MQWIH Structure -- Work Information Header                       */
 /*********************************************************************/

 typedef struct tagMQWIH {
   MQCHAR4   StrucId;         /* Structure identifier */
   MQLONG    Version;         /* Structure version number */
   MQLONG    StrucLength;     /* Length of MQWIH structure */
   MQLONG    Encoding;        /* Numeric encoding of data that follows
                                 MQWIH */
   MQLONG    CodedCharSetId;  /* Character-set identifier of data that
                                 follows MQWIH */
   MQCHAR8   Format;          /* Format name of data that follows
                                 MQWIH */
   MQLONG    Flags;           /* Flags */
   MQCHAR32  ServiceName;     /* Service name */
   MQCHAR8   ServiceStep;     /* Service step name */
   MQBYTE16  MsgToken;        /* Message token */
   MQCHAR32  Reserved;        /* Reserved */
 } MQWIH;
 typedef MQWIH MQPOINTER PMQWIH;

 #define MQWIH_DEFAULT {MQWIH_STRUC_ID_ARRAY},\
                       MQWIH_VERSION_1,\
                       MQWIH_LENGTH_1,\
                       0L,\
                       MQCCSI_UNDEFINED,\
                       {MQFMT_NONE_ARRAY},\
                       MQWIH_NONE,\
                       {' ',' ',' ',' ',' ',' ',' ',' ',\
                       ' ',' ',' ',' ',' ',' ',' ',' ',\
                       ' ',' ',' ',' ',' ',' ',' ',' ',\
                       ' ',' ',' ',' ',' ',' ',' ',' '},\
                       {' ',' ',' ',' ',' ',' ',' ',' '},\
                       {MQMTOK_NONE_ARRAY},\
                       {' ',' ',' ',' ',' ',' ',' ',' ',\
                       ' ',' ',' ',' ',' ',' ',' ',' ',\
                       ' ',' ',' ',' ',' ',' ',' ',' ',\
                       ' ',' ',' ',' ',' ',' ',' ',' '}

 /*********************************************************************/
 /*  MQXQH Structure -- Transmission Queue Header                     */
 /*********************************************************************/

 typedef struct tagMQXQH {
   MQCHAR4   StrucId;         /* Structure identifier */
   MQLONG    Version;         /* Structure version number */
   MQCHAR48  RemoteQName;     /* Name of destination queue */
   MQCHAR48  RemoteQMgrName;  /* Name of destination queue manager */
   MQMD1     MsgDesc;         /* Original message descriptor */
 } MQXQH;
 typedef MQXQH MQPOINTER PMQXQH;

 #define MQXQH_DEFAULT {MQXQH_STRUC_ID_ARRAY},\
                       MQXQH_VERSION_1,\
                       {""},\
                       {""},\
                       {MQMD1_DEFAULT}


 /*********************************************************************/
 /*  MQBACK Function -- Back Out Changes                              */
 /*********************************************************************/

 void MQENTRY MQBACK (
   MQHCONN  Hconn,      /* Connection handle */
   PMQLONG  pCompCode,  /* Completion code */
   PMQLONG  pReason);   /* Reason code qualifying CompCode */


 /*********************************************************************/
 /*  MQBEGIN Function -- Begin Unit of Work                           */
 /*********************************************************************/

 void MQENTRY MQBEGIN (
   MQHCONN  Hconn,          /* Connection handle */
   PMQVOID  pBeginOptions,  /* Options that control the action of
                               MQBEGIN */
   PMQLONG  pCompCode,      /* Completion code */
   PMQLONG  pReason);       /* Reason code qualifying CompCode */


 /*********************************************************************/
 /*  MQCLOSE Function -- Close Object                                 */
 /*********************************************************************/

 void MQENTRY MQCLOSE (
   MQHCONN  Hconn,      /* Connection handle */
   PMQHOBJ  pHobj,      /* Object handle */
   MQLONG   Options,    /* Options that control the action of MQCLOSE */
   PMQLONG  pCompCode,  /* Completion code */
   PMQLONG  pReason);   /* Reason code qualifying CompCode */


 /*********************************************************************/
 /*  MQCMIT Function -- Commit Changes                                */
 /*********************************************************************/

 void MQENTRY MQCMIT (
   MQHCONN  Hconn,      /* Connection handle */
   PMQLONG  pCompCode,  /* Completion code */
   PMQLONG  pReason);   /* Reason code qualifying CompCode */


 /*********************************************************************/
 /*  MQCONN Function -- Connect Queue Manager                         */
 /*********************************************************************/

 void MQENTRY MQCONN (
   PMQCHAR   pQMgrName,  /* Name of queue manager */
   PMQHCONN  pHconn,     /* Connection handle */
   PMQLONG   pCompCode,  /* Completion code */
   PMQLONG   pReason);   /* Reason code qualifying CompCode */


 /*********************************************************************/
 /*  MQCONNX Function -- Connect Queue Manager (Extended)             */
 /*********************************************************************/

 void MQENTRY MQCONNX (
   PMQCHAR   pQMgrName,     /* Name of queue manager */
   PMQCNO    pConnectOpts,  /* Options that control the action of
                               MQCONNX */
   PMQHCONN  pHconn,        /* Connection handle */
   PMQLONG   pCompCode,     /* Completion code */
   PMQLONG   pReason);      /* Reason code qualifying CompCode */


 /*********************************************************************/
 /*  MQDISC Function -- Disconnect Queue Manager                      */
 /*********************************************************************/

 void MQENTRY MQDISC (
   PMQHCONN  pHconn,     /* Connection handle */
   PMQLONG   pCompCode,  /* Completion code */
   PMQLONG   pReason);   /* Reason code qualifying CompCode */


 /*********************************************************************/
 /*  MQGET Function -- Get Message                                    */
 /*********************************************************************/

 void MQENTRY MQGET (
   MQHCONN  Hconn,         /* Connection handle */
   MQHOBJ   Hobj,          /* Object handle */
   PMQVOID  pMsgDesc,      /* Message descriptor */
   PMQVOID  pGetMsgOpts,   /* Options that control the action of
                              MQGET */
   MQLONG   BufferLength,  /* Length in bytes of the Buffer area */
   PMQVOID  pBuffer,       /* Area to contain the message data */
   PMQLONG  pDataLength,   /* Length of the message */
   PMQLONG  pCompCode,     /* Completion code */
   PMQLONG  pReason);      /* Reason code qualifying CompCode */


 /*********************************************************************/
 /*  MQINQ Function -- Inquire Object Attributes                      */
 /*********************************************************************/

 void MQENTRY MQINQ (
   MQHCONN  Hconn,           /* Connection handle */
   MQHOBJ   Hobj,            /* Object handle */
   MQLONG   SelectorCount,   /* Count of selectors */
   PMQLONG  pSelectors,      /* Array of attribute selectors */
   MQLONG   IntAttrCount,    /* Count of integer attributes */
   PMQLONG  pIntAttrs,       /* Array of integer attributes */
   MQLONG   CharAttrLength,  /* Length of character attributes buffer */
   PMQCHAR  pCharAttrs,      /* Character attributes */
   PMQLONG  pCompCode,       /* Completion code */
   PMQLONG  pReason);        /* Reason code qualifying CompCode */


 /*********************************************************************/
 /*  MQOPEN Function -- Open Object                                   */
 /*********************************************************************/

 void MQENTRY MQOPEN (
   MQHCONN  Hconn,      /* Connection handle */
   PMQVOID  pObjDesc,   /* Object descriptor */
   MQLONG   Options,    /* Options that control the action of MQOPEN */
   PMQHOBJ  pHobj,      /* Object handle */
   PMQLONG  pCompCode,  /* Completion code */
   PMQLONG  pReason);   /* Reason code qualifying CompCode */


 /*********************************************************************/
 /*  MQPUT Function -- Put Message                                    */
 /*********************************************************************/

 void MQENTRY MQPUT (
   MQHCONN  Hconn,         /* Connection handle */
   MQHOBJ   Hobj,          /* Object handle */
   PMQVOID  pMsgDesc,      /* Message descriptor */
   PMQVOID  pPutMsgOpts,   /* Options that control the action of
                              MQPUT */
   MQLONG   BufferLength,  /* Length of the message in Buffer */
   PMQVOID  pBuffer,       /* Message data */
   PMQLONG  pCompCode,     /* Completion code */
   PMQLONG  pReason);      /* Reason code qualifying CompCode */


 /*********************************************************************/
 /*  MQPUT1 Function -- Put One Message                               */
 /*********************************************************************/

 void MQENTRY MQPUT1 (
   MQHCONN  Hconn,         /* Connection handle */
   PMQVOID  pObjDesc,      /* Object descriptor */
   PMQVOID  pMsgDesc,      /* Message descriptor */
   PMQVOID  pPutMsgOpts,   /* Options that control the action of
                              MQPUT1 */
   MQLONG   BufferLength,  /* Length of the message in Buffer */
   PMQVOID  pBuffer,       /* Message data */
   PMQLONG  pCompCode,     /* Completion code */
   PMQLONG  pReason);      /* Reason code qualifying CompCode */


 /*********************************************************************/
 /*  MQSET Function -- Set Object Attributes                          */
 /*********************************************************************/

 void MQENTRY MQSET (
   MQHCONN  Hconn,           /* Connection handle */
   MQHOBJ   Hobj,            /* Object handle */
   MQLONG   SelectorCount,   /* Count of selectors */
   PMQLONG  pSelectors,      /* Array of attribute selectors */
   MQLONG   IntAttrCount,    /* Count of integer attributes */
   PMQLONG  pIntAttrs,       /* Array of integer attributes */
   MQLONG   CharAttrLength,  /* Length of character attributes buffer */
   PMQCHAR  pCharAttrs,      /* Character attributes */
   PMQLONG  pCompCode,       /* Completion code */
   PMQLONG  pReason);        /* Reason code qualifying CompCode */


 #if defined(__cplusplus)
   }
 #endif

 /*********************************************************************/
 /*  End of CMQC                                                      */
 /*********************************************************************/

 #endif  /* End of header file */
