 #if !defined(MQCFC_INCLUDED)          /* File not yet included?      */
   #define MQCFC_INCLUDED              /* Show file now included      */
 /*********************************************************************/
 /*                                                                   */
 /*                  IBM MQSeries for Linux/Intel                     */
 /*                                                                   */
 /*  HEADER NAME:    CMQCFC                                           */
 /*                                                                   */
 /*  DESCRIPTION:    Declarations for PCF and Events                  */
 /*                                                                   */
 /*********************************************************************/
 /*  @START_COPYRIGHT@                                                */
 /*  Licensed Materials - Property of IBM                             */
 /*                                                                   */
 /*  0783881, 5639-I84                                                */
 /*                                                                   */
 /*  (C) Copyright IBM Corporation 1995, 2000.                        */
 /*                                                                   */
 /*  Status: Version 5 Release 2                                      */
 /*  @END_COPYRIGHT@                                                  */
 /*********************************************************************/
 /*                                                                   */
 /*  FUNCTION:       This file declares the structures and named      */
 /*                  constants for PCF and event messages.            */
 /*                                                                   */
 /*  PROCESSOR:      C                                                */
 /*                                                                   */
 /*********************************************************************/

 #if defined(__cplusplus)
   extern "C" {
 #endif

 /*********************************************************************/
 /*  Values Related to MQCFH Structure                                */
 /*********************************************************************/

 /* Structure Length */
 #define MQCFH_STRUC_LENGTH 36L

 /* Structure Version Number */
 #define MQCFH_VERSION_1       1L
 #define MQCFH_CURRENT_VERSION 1L

 /* Command Codes */
 #define MQCMD_CHANGE_Q_MGR           1L
 #define MQCMD_INQUIRE_Q_MGR          2L
 #define MQCMD_CHANGE_PROCESS         3L
 #define MQCMD_COPY_PROCESS           4L
 #define MQCMD_CREATE_PROCESS         5L
 #define MQCMD_DELETE_PROCESS         6L
 #define MQCMD_INQUIRE_PROCESS        7L
 #define MQCMD_CHANGE_Q               8L
 #define MQCMD_CLEAR_Q                9L
 #define MQCMD_COPY_Q                 10L
 #define MQCMD_CREATE_Q               11L
 #define MQCMD_DELETE_Q               12L
 #define MQCMD_INQUIRE_Q              13L
 #define MQCMD_RESET_Q_STATS          17L
 #define MQCMD_INQUIRE_Q_NAMES        18L
 #define MQCMD_INQUIRE_PROCESS_NAMES  19L
 #define MQCMD_INQUIRE_CHANNEL_NAMES  20L
 #define MQCMD_CHANGE_CHANNEL         21L
 #define MQCMD_COPY_CHANNEL           22L
 #define MQCMD_CREATE_CHANNEL         23L
 #define MQCMD_DELETE_CHANNEL         24L
 #define MQCMD_INQUIRE_CHANNEL        25L
 #define MQCMD_PING_CHANNEL           26L
 #define MQCMD_RESET_CHANNEL          27L
 #define MQCMD_START_CHANNEL          28L
 #define MQCMD_STOP_CHANNEL           29L
 #define MQCMD_START_CHANNEL_INIT     30L
 #define MQCMD_START_CHANNEL_LISTENER 31L
 #define MQCMD_CHANGE_NAMELIST        32L
 #define MQCMD_COPY_NAMELIST          33L
 #define MQCMD_CREATE_NAMELIST        34L
 #define MQCMD_DELETE_NAMELIST        35L
 #define MQCMD_INQUIRE_NAMELIST       36L
 #define MQCMD_INQUIRE_NAMELIST_NAMES 37L
 #define MQCMD_ESCAPE                 38L
 #define MQCMD_RESOLVE_CHANNEL        39L
 #define MQCMD_PING_Q_MGR             40L
 #define MQCMD_INQUIRE_CHANNEL_STATUS 42L
 #define MQCMD_Q_MGR_EVENT            44L
 #define MQCMD_PERFM_EVENT            45L
 #define MQCMD_CHANNEL_EVENT          46L
 #define MQCMD_DELETE_PUBLICATION     60L
 #define MQCMD_DEREGISTER_PUBLISHER   61L
 #define MQCMD_DEREGISTER_SUBSCRIBER  62L
 #define MQCMD_PUBLISH                63L
 #define MQCMD_REGISTER_PUBLISHER     64L
 #define MQCMD_REGISTER_SUBSCRIBER    65L
 #define MQCMD_REQUEST_UPDATE         66L
 #define MQCMD_BROKER_INTERNAL        67L
 #define MQCMD_INQUIRE_CLUSTER_Q_MGR  70L
 #define MQCMD_RESUME_Q_MGR_CLUSTER   71L
 #define MQCMD_SUSPEND_Q_MGR_CLUSTER  72L
 #define MQCMD_REFRESH_CLUSTER        73L
 #define MQCMD_RESET_CLUSTER          74L
 #define MQCMD_REFRESH_SECURITY       78L
 #define MQCMD_NONE                   0L

 /* Control Options */
 #define MQCFC_LAST     1L
 #define MQCFC_NOT_LAST 0L

 /* Reason Codes */
 #define MQRCCF_CFH_TYPE_ERROR          3001L
 #define MQRCCF_CFH_LENGTH_ERROR        3002L
 #define MQRCCF_CFH_VERSION_ERROR       3003L
 #define MQRCCF_CFH_MSG_SEQ_NUMBER_ERR  3004L
 #define MQRCCF_CFH_CONTROL_ERROR       3005L
 #define MQRCCF_CFH_PARM_COUNT_ERROR    3006L
 #define MQRCCF_CFH_COMMAND_ERROR       3007L
 #define MQRCCF_COMMAND_FAILED          3008L
 #define MQRCCF_CFIN_LENGTH_ERROR       3009L
 #define MQRCCF_CFST_LENGTH_ERROR       3010L
 #define MQRCCF_CFST_STRING_LENGTH_ERR  3011L
 #define MQRCCF_FORCE_VALUE_ERROR       3012L
 #define MQRCCF_STRUCTURE_TYPE_ERROR    3013L
 #define MQRCCF_CFIN_PARM_ID_ERROR      3014L
 #define MQRCCF_CFST_PARM_ID_ERROR      3015L
 #define MQRCCF_MSG_LENGTH_ERROR        3016L
 #define MQRCCF_CFIN_DUPLICATE_PARM     3017L
 #define MQRCCF_CFST_DUPLICATE_PARM     3018L
 #define MQRCCF_PARM_COUNT_TOO_SMALL    3019L
 #define MQRCCF_PARM_COUNT_TOO_BIG      3020L
 #define MQRCCF_Q_ALREADY_IN_CELL       3021L
 #define MQRCCF_Q_TYPE_ERROR            3022L
 #define MQRCCF_MD_FORMAT_ERROR         3023L
 #define MQRCCF_CFSL_LENGTH_ERROR       3024L
 #define MQRCCF_REPLACE_VALUE_ERROR     3025L
 #define MQRCCF_CFIL_DUPLICATE_VALUE    3026L
 #define MQRCCF_CFIL_COUNT_ERROR        3027L
 #define MQRCCF_CFIL_LENGTH_ERROR       3028L
 #define MQRCCF_QUIESCE_VALUE_ERROR     3029L
 #define MQRCCF_MSG_SEQ_NUMBER_ERROR    3030L
 #define MQRCCF_PING_DATA_COUNT_ERROR   3031L
 #define MQRCCF_PING_DATA_COMPARE_ERROR 3032L
 #define MQRCCF_CFSL_PARM_ID_ERROR      3033L
 #define MQRCCF_CHANNEL_TYPE_ERROR      3034L
 #define MQRCCF_PARM_SEQUENCE_ERROR     3035L
 #define MQRCCF_XMIT_PROTOCOL_TYPE_ERR  3036L
 #define MQRCCF_BATCH_SIZE_ERROR        3037L
 #define MQRCCF_DISC_INT_ERROR          3038L
 #define MQRCCF_SHORT_RETRY_ERROR       3039L
 #define MQRCCF_SHORT_TIMER_ERROR       3040L
 #define MQRCCF_LONG_RETRY_ERROR        3041L
 #define MQRCCF_LONG_TIMER_ERROR        3042L
 #define MQRCCF_SEQ_NUMBER_WRAP_ERROR   3043L
 #define MQRCCF_MAX_MSG_LENGTH_ERROR    3044L
 #define MQRCCF_PUT_AUTH_ERROR          3045L
 #define MQRCCF_PURGE_VALUE_ERROR       3046L
 #define MQRCCF_CFIL_PARM_ID_ERROR      3047L
 #define MQRCCF_MSG_TRUNCATED           3048L
 #define MQRCCF_CCSID_ERROR             3049L
 #define MQRCCF_ENCODING_ERROR          3050L
 #define MQRCCF_DATA_CONV_VALUE_ERROR   3052L
 #define MQRCCF_INDOUBT_VALUE_ERROR     3053L
 #define MQRCCF_ESCAPE_TYPE_ERROR       3054L
 #define MQRCCF_CHANNEL_TABLE_ERROR     3062L
 #define MQRCCF_MCA_TYPE_ERROR          3063L
 #define MQRCCF_CHL_INST_TYPE_ERROR     3064L
 #define MQRCCF_CHL_STATUS_NOT_FOUND    3065L
 #define MQRCCF_CFSL_DUPLICATE_PARM     3066L
 #define MQRCCF_CFSL_TOTAL_LENGTH_ERROR 3067L
 #define MQRCCF_CFSL_COUNT_ERROR        3068L
 #define MQRCCF_CFSL_STRING_LENGTH_ERR  3069L
 #define MQRCCF_BROKER_DELETED          3070L
 #define MQRCCF_STREAM_ERROR            3071L
 #define MQRCCF_TOPIC_ERROR             3072L
 #define MQRCCF_NOT_REGISTERED          3073L
 #define MQRCCF_Q_MGR_NAME_ERROR        3074L
 #define MQRCCF_INCORRECT_STREAM        3075L
 #define MQRCCF_Q_NAME_ERROR            3076L
 #define MQRCCF_NO_RETAINED_MSG         3077L
 #define MQRCCF_DUPLICATE_IDENTITY      3078L
 #define MQRCCF_INCORRECT_Q             3079L
 #define MQRCCF_CORREL_ID_ERROR         3080L
 #define MQRCCF_NOT_AUTHORIZED          3081L
 #define MQRCCF_UNKNOWN_STREAM          3082L
 #define MQRCCF_REG_OPTIONS_ERROR       3083L
 #define MQRCCF_PUB_OPTIONS_ERROR       3084L
 #define MQRCCF_UNKNOWN_BROKER          3085L
 #define MQRCCF_Q_MGR_CCSID_ERROR       3086L
 #define MQRCCF_DEL_OPTIONS_ERROR       3087L
 #define MQRCCF_CLUSTER_NAME_CONFLICT   3088L
 #define MQRCCF_REPOS_NAME_CONFLICT     3089L
 #define MQRCCF_CLUSTER_Q_USAGE_ERROR   3090L
 #define MQRCCF_ACTION_VALUE_ERROR      3091L
 #define MQRCCF_COMMS_LIBRARY_ERROR     3092L
 #define MQRCCF_NETBIOS_NAME_ERROR      3093L
 #define MQRCCF_BROKER_COMMAND_FAILED   3094L
 #define MQRCCF_FILTER_ERROR            3150L
 #define MQRCCF_WRONG_USER              3151L
 #define MQRCCF_OBJECT_ALREADY_EXISTS   4001L
 #define MQRCCF_OBJECT_WRONG_TYPE       4002L
 #define MQRCCF_LIKE_OBJECT_WRONG_TYPE  4003L
 #define MQRCCF_OBJECT_OPEN             4004L
 #define MQRCCF_ATTR_VALUE_ERROR        4005L
 #define MQRCCF_UNKNOWN_Q_MGR           4006L
 #define MQRCCF_Q_WRONG_TYPE            4007L
 #define MQRCCF_OBJECT_NAME_ERROR       4008L
 #define MQRCCF_ALLOCATE_FAILED         4009L
 #define MQRCCF_HOST_NOT_AVAILABLE      4010L
 #define MQRCCF_CONFIGURATION_ERROR     4011L
 #define MQRCCF_CONNECTION_REFUSED      4012L
 #define MQRCCF_ENTRY_ERROR             4013L
 #define MQRCCF_SEND_FAILED             4014L
 #define MQRCCF_RECEIVED_DATA_ERROR     4015L
 #define MQRCCF_RECEIVE_FAILED          4016L
 #define MQRCCF_CONNECTION_CLOSED       4017L
 #define MQRCCF_NO_STORAGE              4018L
 #define MQRCCF_NO_COMMS_MANAGER        4019L
 #define MQRCCF_LISTENER_NOT_STARTED    4020L
 #define MQRCCF_BIND_FAILED             4024L
 #define MQRCCF_CHANNEL_INDOUBT         4025L
 #define MQRCCF_MQCONN_FAILED           4026L
 #define MQRCCF_MQOPEN_FAILED           4027L
 #define MQRCCF_MQGET_FAILED            4028L
 #define MQRCCF_MQPUT_FAILED            4029L
 #define MQRCCF_PING_ERROR              4030L
 #define MQRCCF_CHANNEL_IN_USE          4031L
 #define MQRCCF_CHANNEL_NOT_FOUND       4032L
 #define MQRCCF_UNKNOWN_REMOTE_CHANNEL  4033L
 #define MQRCCF_REMOTE_QM_UNAVAILABLE   4034L
 #define MQRCCF_REMOTE_QM_TERMINATING   4035L
 #define MQRCCF_MQINQ_FAILED            4036L
 #define MQRCCF_NOT_XMIT_Q              4037L
 #define MQRCCF_CHANNEL_DISABLED        4038L
 #define MQRCCF_USER_EXIT_NOT_AVAILABLE 4039L
 #define MQRCCF_COMMIT_FAILED           4040L
 #define MQRCCF_CHANNEL_ALREADY_EXISTS  4042L
 #define MQRCCF_DATA_TOO_LARGE          4043L
 #define MQRCCF_CHANNEL_NAME_ERROR      4044L
 #define MQRCCF_XMIT_Q_NAME_ERROR       4045L
 #define MQRCCF_MCA_NAME_ERROR          4047L
 #define MQRCCF_SEND_EXIT_NAME_ERROR    4048L
 #define MQRCCF_SEC_EXIT_NAME_ERROR     4049L
 #define MQRCCF_MSG_EXIT_NAME_ERROR     4050L
 #define MQRCCF_RCV_EXIT_NAME_ERROR     4051L
 #define MQRCCF_XMIT_Q_NAME_WRONG_TYPE  4052L
 #define MQRCCF_MCA_NAME_WRONG_TYPE     4053L
 #define MQRCCF_DISC_INT_WRONG_TYPE     4054L
 #define MQRCCF_SHORT_RETRY_WRONG_TYPE  4055L
 #define MQRCCF_SHORT_TIMER_WRONG_TYPE  4056L
 #define MQRCCF_LONG_RETRY_WRONG_TYPE   4057L
 #define MQRCCF_LONG_TIMER_WRONG_TYPE   4058L
 #define MQRCCF_PUT_AUTH_WRONG_TYPE     4059L
 #define MQRCCF_MISSING_CONN_NAME       4061L
 #define MQRCCF_CONN_NAME_ERROR         4062L
 #define MQRCCF_MQSET_FAILED            4063L
 #define MQRCCF_CHANNEL_NOT_ACTIVE      4064L
 #define MQRCCF_TERMINATED_BY_SEC_EXIT  4065L
 #define MQRCCF_DYNAMIC_Q_SCOPE_ERROR   4067L
 #define MQRCCF_CELL_DIR_NOT_AVAILABLE  4068L
 #define MQRCCF_MR_COUNT_ERROR          4069L
 #define MQRCCF_MR_COUNT_WRONG_TYPE     4070L
 #define MQRCCF_MR_EXIT_NAME_ERROR      4071L
 #define MQRCCF_MR_EXIT_NAME_WRONG_TYPE 4072L
 #define MQRCCF_MR_INTERVAL_ERROR       4073L
 #define MQRCCF_MR_INTERVAL_WRONG_TYPE  4074L
 #define MQRCCF_NPM_SPEED_ERROR         4075L
 #define MQRCCF_NPM_SPEED_WRONG_TYPE    4076L
 #define MQRCCF_HB_INTERVAL_ERROR       4077L
 #define MQRCCF_HB_INTERVAL_WRONG_TYPE  4078L
 #define MQRCCF_CHAD_ERROR              4079L
 #define MQRCCF_CHAD_WRONG_TYPE         4080L
 #define MQRCCF_CHAD_EVENT_ERROR        4081L
 #define MQRCCF_CHAD_EVENT_WRONG_TYPE   4082L
 #define MQRCCF_CHAD_EXIT_ERROR         4083L
 #define MQRCCF_CHAD_EXIT_WRONG_TYPE    4084L
 #define MQRCCF_SUPPRESSED_BY_EXIT      4085L
 #define MQRCCF_BATCH_INT_ERROR         4086L
 #define MQRCCF_BATCH_INT_WRONG_TYPE    4087L
 #define MQRCCF_NET_PRIORITY_ERROR      4088L
 #define MQRCCF_NET_PRIORITY_WRONG_TYPE 4089L
 #define MQRCCF_CHANNEL_CLOSED          4090L

 /*********************************************************************/
 /*  Values Related to MQCFIL Structure                               */
 /*********************************************************************/

 /* Structure Length (Fixed Part) */
 #define MQCFIL_STRUC_LENGTH_FIXED 16L


 /*********************************************************************/
 /*  Values Related to MQCFIN Structure                               */
 /*********************************************************************/

 /* Structure Length */
 #define MQCFIN_STRUC_LENGTH 16L


 /*********************************************************************/
 /*  Values Related to MQCFSL Structure                               */
 /*********************************************************************/

 /* Structure Length (Fixed Part) */
 #define MQCFSL_STRUC_LENGTH_FIXED 24L


 /*********************************************************************/
 /*  Values Related to MQCFST Structure                               */
 /*********************************************************************/

 /* Structure Length (Fixed Part) */
 #define MQCFST_STRUC_LENGTH_FIXED 20L


 /*********************************************************************/
 /*  Values Related to All Structures                                 */
 /*********************************************************************/

 /* Structure Type */
 #define MQCFT_COMMAND      1L
 #define MQCFT_RESPONSE     2L
 #define MQCFT_INTEGER      3L
 #define MQCFT_STRING       4L
 #define MQCFT_INTEGER_LIST 5L
 #define MQCFT_STRING_LIST  6L
 #define MQCFT_EVENT        7L
 #define MQCFT_USER         8L


 /*********************************************************************/
 /*  Values Related to Integer Parameter Structures                   */
 /*********************************************************************/

 /* Integer Parameter Types */
 #define MQIACF_FIRST                 1001L
 #define MQIACF_Q_MGR_ATTRS           1001L
 #define MQIACF_Q_ATTRS               1002L
 #define MQIACF_PROCESS_ATTRS         1003L
 #define MQIACF_NAMELIST_ATTRS        1004L
 #define MQIACF_FORCE                 1005L
 #define MQIACF_REPLACE               1006L
 #define MQIACF_PURGE                 1007L
 #define MQIACF_QUIESCE               1008L
 #define MQIACF_ALL                   1009L
 #define MQIACF_PARAMETER_ID          1012L
 #define MQIACF_ERROR_ID              1013L
 #define MQIACF_ERROR_IDENTIFIER      1013L
 #define MQIACF_SELECTOR              1014L
 #define MQIACF_CHANNEL_ATTRS         1015L
 #define MQIACF_ESCAPE_TYPE           1017L
 #define MQIACF_ERROR_OFFSET          1018L
 #define MQIACF_REASON_QUALIFIER      1020L
 #define MQIACF_COMMAND               1021L
 #define MQIACF_OPEN_OPTIONS          1022L
 #define MQIACF_AUX_ERROR_DATA_INT_1  1070L
 #define MQIACF_AUX_ERROR_DATA_INT_2  1071L
 #define MQIACF_CONV_REASON_CODE      1072L
 #define MQIACF_BRIDGE_TYPE           1073L
 #define MQIACF_INQUIRY               1074L
 #define MQIACF_WAIT_INTERVAL         1075L
 #define MQIACF_OPTIONS               1076L
 #define MQIACF_BROKER_OPTIONS        1077L
 #define MQIACF_SEQUENCE_NUMBER       1079L
 #define MQIACF_INTEGER_DATA          1080L
 #define MQIACF_REGISTRATION_OPTIONS  1081L
 #define MQIACF_PUBLICATION_OPTIONS   1082L
 #define MQIACF_CLUSTER_INFO          1083L
 #define MQIACF_Q_MGR_DEFINITION_TYPE 1084L
 #define MQIACF_Q_MGR_TYPE            1085L
 #define MQIACF_ACTION                1086L
 #define MQIACF_SUSPEND               1087L
 #define MQIACF_BROKER_COUNT          1088L
 #define MQIACF_APPL_COUNT            1089L
 #define MQIACF_ANONYMOUS_COUNT       1090L
 #define MQIACF_REG_REG_OPTIONS       1091L
 #define MQIACF_DELETE_OPTIONS        1092L
 #define MQIACF_CLUSTER_Q_MGR_ATTRS   1093L
 #define MQIACF_LAST_USED             1093L

 #define MQIACH_FIRST                   1501L
 #define MQIACH_XMIT_PROTOCOL_TYPE      1501L
 #define MQIACH_BATCH_SIZE              1502L
 #define MQIACH_DISC_INTERVAL           1503L
 #define MQIACH_SHORT_TIMER             1504L
 #define MQIACH_SHORT_RETRY             1505L
 #define MQIACH_LONG_TIMER              1506L
 #define MQIACH_LONG_RETRY              1507L
 #define MQIACH_PUT_AUTHORITY           1508L
 #define MQIACH_SEQUENCE_NUMBER_WRAP    1509L
 #define MQIACH_MAX_MSG_LENGTH          1510L
 #define MQIACH_CHANNEL_TYPE            1511L
 #define MQIACH_DATA_COUNT              1512L
 #define MQIACH_MSG_SEQUENCE_NUMBER     1514L
 #define MQIACH_DATA_CONVERSION         1515L
 #define MQIACH_IN_DOUBT                1516L
 #define MQIACH_MCA_TYPE                1517L
 #define MQIACH_CHANNEL_INSTANCE_TYPE   1523L
 #define MQIACH_CHANNEL_INSTANCE_ATTRS  1524L
 #define MQIACH_CHANNEL_ERROR_DATA      1525L
 #define MQIACH_CHANNEL_TABLE           1526L
 #define MQIACH_CHANNEL_STATUS          1527L
 #define MQIACH_INDOUBT_STATUS          1528L
 #define MQIACH_LAST_SEQ_NUMBER         1529L
 #define MQIACH_LAST_SEQUENCE_NUMBER    1529L
 #define MQIACH_CURRENT_MSGS            1531L
 #define MQIACH_CURRENT_SEQ_NUMBER      1532L
 #define MQIACH_CURRENT_SEQUENCE_NUMBER 1532L
 #define MQIACH_MSGS                    1534L
 #define MQIACH_BYTES_SENT              1535L
 #define MQIACH_BYTES_RCVD              1536L
 #define MQIACH_BYTES_RECEIVED          1536L
 #define MQIACH_BATCHES                 1537L
 #define MQIACH_BUFFERS_SENT            1538L
 #define MQIACH_BUFFERS_RCVD            1539L
 #define MQIACH_BUFFERS_RECEIVED        1539L
 #define MQIACH_LONG_RETRIES_LEFT       1540L
 #define MQIACH_SHORT_RETRIES_LEFT      1541L
 #define MQIACH_MCA_STATUS              1542L
 #define MQIACH_STOP_REQUESTED          1543L
 #define MQIACH_MR_COUNT                1544L
 #define MQIACH_MR_INTERVAL             1545L
 #define MQIACH_NPM_SPEED               1562L
 #define MQIACH_HB_INTERVAL             1563L
 #define MQIACH_BATCH_INTERVAL          1564L
 #define MQIACH_NETWORK_PRIORITY        1565L
 #define MQIACH_LAST_USED               1565L


 /*********************************************************************/
 /*  Values Related to Character Parameter Structures                 */
 /*********************************************************************/

 /* Character Parameter Types */
 #define MQCACF_FIRST                   3001L
 #define MQCACF_FROM_Q_NAME             3001L
 #define MQCACF_TO_Q_NAME               3002L
 #define MQCACF_FROM_PROCESS_NAME       3003L
 #define MQCACF_TO_PROCESS_NAME         3004L
 #define MQCACF_FROM_NAMELIST_NAME      3005L
 #define MQCACF_TO_NAMELIST_NAME        3006L
 #define MQCACF_FROM_CHANNEL_NAME       3007L
 #define MQCACF_TO_CHANNEL_NAME         3008L
 #define MQCACF_Q_NAMES                 3011L
 #define MQCACF_PROCESS_NAMES           3012L
 #define MQCACF_NAMELIST_NAMES          3013L
 #define MQCACF_ESCAPE_TEXT             3014L
 #define MQCACF_LOCAL_Q_NAMES           3015L
 #define MQCACF_MODEL_Q_NAMES           3016L
 #define MQCACF_ALIAS_Q_NAMES           3017L
 #define MQCACF_REMOTE_Q_NAMES          3018L
 #define MQCACF_SENDER_CHANNEL_NAMES    3019L
 #define MQCACF_SERVER_CHANNEL_NAMES    3020L
 #define MQCACF_REQUESTER_CHANNEL_NAMES 3021L
 #define MQCACF_RECEIVER_CHANNEL_NAMES  3022L
 #define MQCACF_OBJECT_Q_MGR_NAME       3023L
 #define MQCACF_APPL_NAME               3024L
 #define MQCACF_USER_IDENTIFIER         3025L
 #define MQCACF_AUX_ERROR_DATA_STR_1    3026L
 #define MQCACF_AUX_ERROR_DATA_STR_2    3027L
 #define MQCACF_AUX_ERROR_DATA_STR_3    3028L
 #define MQCACF_BRIDGE_NAME             3029L
 #define MQCACF_STREAM_NAME             3030L
 #define MQCACF_TOPIC                   3031L
 #define MQCACF_PARENT_Q_MGR_NAME       3032L
 #define MQCACF_PUBLISH_TIMESTAMP       3034L
 #define MQCACF_STRING_DATA             3035L
 #define MQCACF_SUPPORTED_STREAM_NAME   3036L
 #define MQCACF_REG_TOPIC               3037L
 #define MQCACF_REG_TIME                3038L
 #define MQCACF_REG_USER_ID             3039L
 #define MQCACF_CHILD_Q_MGR_NAME        3040L
 #define MQCACF_REG_STREAM_NAME         3041L
 #define MQCACF_REG_Q_MGR_NAME          3042L
 #define MQCACF_REG_Q_NAME              3043L
 #define MQCACF_REG_CORREL_ID           3044L
 #define MQCACF_LAST_USED               3044L

 #define MQCACH_FIRST               3501L
 #define MQCACH_CHANNEL_NAME        3501L
 #define MQCACH_DESC                3502L
 #define MQCACH_MODE_NAME           3503L
 #define MQCACH_TP_NAME             3504L
 #define MQCACH_XMIT_Q_NAME         3505L
 #define MQCACH_CONNECTION_NAME     3506L
 #define MQCACH_MCA_NAME            3507L
 #define MQCACH_SEC_EXIT_NAME       3508L
 #define MQCACH_MSG_EXIT_NAME       3509L
 #define MQCACH_SEND_EXIT_NAME      3510L
 #define MQCACH_RCV_EXIT_NAME       3511L
 #define MQCACH_CHANNEL_NAMES       3512L
 #define MQCACH_SEC_EXIT_USER_DATA  3513L
 #define MQCACH_MSG_EXIT_USER_DATA  3514L
 #define MQCACH_SEND_EXIT_USER_DATA 3515L
 #define MQCACH_RCV_EXIT_USER_DATA  3516L
 #define MQCACH_USER_ID             3517L
 #define MQCACH_PASSWORD            3518L
 #define MQCACH_LAST_MSG_TIME       3524L
 #define MQCACH_LAST_MSG_DATE       3525L
 #define MQCACH_MCA_USER_ID         3527L
 #define MQCACH_CHANNEL_START_TIME  3528L
 #define MQCACH_CHANNEL_START_DATE  3529L
 #define MQCACH_MCA_JOB_NAME        3530L
 #define MQCACH_LAST_LUWID          3531L
 #define MQCACH_CURRENT_LUWID       3532L
 #define MQCACH_FORMAT_NAME         3533L
 #define MQCACH_MR_EXIT_NAME        3534L
 #define MQCACH_MR_EXIT_USER_DATA   3535L
 #define MQCACH_LAST_USED           3535L


 /*********************************************************************/
 /*  Parameter Values                                                 */
 /*********************************************************************/

 /* Action Option */
 #define MQACT_FORCE_REMOVE 1L

 /* Bridge Type */
 #define MQBT_OTMA 1L

 /* Indoubt Status */
 #define MQCHIDS_NOT_INDOUBT 0L
 #define MQCHIDS_INDOUBT     1L

 /* Channel Status */
 #define MQCHS_INACTIVE     0L
 #define MQCHS_BINDING      1L
 #define MQCHS_STARTING     2L
 #define MQCHS_RUNNING      3L
 #define MQCHS_STOPPING     4L
 #define MQCHS_RETRYING     5L
 #define MQCHS_STOPPED      6L
 #define MQCHS_REQUESTING   7L
 #define MQCHS_PAUSED       8L
 #define MQCHS_INITIALIZING 13L

 /* Channel Stop Option */
 #define MQCHSR_STOP_NOT_REQUESTED 0L
 #define MQCHSR_STOP_REQUESTED     1L

 /* Channel Table Type */
 #define MQCHTAB_Q_MGR    1L
 #define MQCHTAB_CLNTCONN 2L

 /* Escape Type */
 #define MQET_MQSC 1L

 /* Event Recording */
 #define MQEVR_DISABLED 0L
 #define MQEVR_ENABLED  1L

 /* Force Control */
 #define MQFC_YES 1L
 #define MQFC_NO  0L

 /* Indoubt Option */
 #define MQIDO_COMMIT  1L
 #define MQIDO_BACKOUT 2L

 /* Message Channel Agent Status */
 #define MQMCAS_STOPPED 0L
 #define MQMCAS_RUNNING 3L

 /* Purge Option */
 #define MQPO_YES 1L
 #define MQPO_NO  0L

 /* Queue Manager Definition Type */
 #define MQQMDT_EXPLICIT_CLUSTER_SENDER 1L
 #define MQQMDT_AUTO_CLUSTER_SENDER     2L
 #define MQQMDT_AUTO_EXP_CLUSTER_SENDER 4L
 #define MQQMDT_CLUSTER_RECEIVER        3L

 /* Queue Manager Type */
 #define MQQMT_NORMAL     0L
 #define MQQMT_REPOSITORY 1L

 /* Quiesce Option */
 #define MQQO_YES 1L
 #define MQQO_NO  0L

 /* Queue Service-Interval Events */
 #define MQQSIE_NONE 0L
 #define MQQSIE_HIGH 1L
 #define MQQSIE_OK   2L

 /* Replace Option */
 #define MQRP_YES 1L
 #define MQRP_NO  0L

 /* Reason Qualifiers */
 #define MQRQ_CONN_NOT_AUTHORIZED      1L
 #define MQRQ_OPEN_NOT_AUTHORIZED      2L
 #define MQRQ_CLOSE_NOT_AUTHORIZED     3L
 #define MQRQ_CMD_NOT_AUTHORIZED       4L
 #define MQRQ_Q_MGR_STOPPING           5L
 #define MQRQ_Q_MGR_QUIESCING          6L
 #define MQRQ_CHANNEL_STOPPED_OK       7L
 #define MQRQ_CHANNEL_STOPPED_ERROR    8L
 #define MQRQ_CHANNEL_STOPPED_RETRY    9L
 #define MQRQ_CHANNEL_STOPPED_DISABLED 10L
 #define MQRQ_BRIDGE_STOPPED_OK        11L
 #define MQRQ_BRIDGE_STOPPED_ERROR     12L

 /* Queue Definition Scope */
 #define MQSCO_Q_MGR 1L
 #define MQSCO_CELL  2L

 /* Suspend Status */
 #define MQSUS_YES 1L
 #define MQSUS_NO  0L


 /*********************************************************************/
 /*  Values Related to Publish/Subscribe                              */
 /*********************************************************************/

 /* Delete Options */
 #define MQDELO_NONE  0x00000000L
 #define MQDELO_LOCAL 0x00000004L

 /* Publication Options */
 #define MQPUBO_NONE                    0x00000000L
 #define MQPUBO_CORREL_ID_AS_IDENTITY   0x00000001L
 #define MQPUBO_RETAIN_PUBLICATION      0x00000002L
 #define MQPUBO_OTHER_SUBSCRIBERS_ONLY  0x00000004L
 #define MQPUBO_NO_REGISTRATION         0x00000008L
 #define MQPUBO_IS_RETAINED_PUBLICATION 0x00000010L

 /* Registration Options */
 #define MQREGO_NONE                    0x00000000L
 #define MQREGO_CORREL_ID_AS_IDENTITY   0x00000001L
 #define MQREGO_ANONYMOUS               0x00000002L
 #define MQREGO_LOCAL                   0x00000004L
 #define MQREGO_DIRECT_REQUESTS         0x00000008L
 #define MQREGO_NEW_PUBLICATIONS_ONLY   0x00000010L
 #define MQREGO_PUBLISH_ON_REQUEST_ONLY 0x00000020L
 #define MQREGO_DEREGISTER_ALL          0x00000040L
 #define MQREGO_INCLUDE_STREAM_NAME     0x00000080L
 #define MQREGO_INFORM_IF_RETAINED      0x00000100L
 #define MQREGO_DUPLICATES_OK           0x00000200L
 #define MQREGO_NON_PERSISTENT          0x00000400L
 #define MQREGO_PERSISTENT              0x00000800L
 #define MQREGO_PERSISTENT_AS_PUBLISH   0x00001000L
 #define MQREGO_PERSISTENT_AS_Q         0x00002000L

 /* User Attribute Selectors */
 #define MQUA_FIRST 65536L
 #define MQUA_LAST  999999999L


 /*********************************************************************/
 /*  MQCFH Structure -- PCF Header                                    */
 /*********************************************************************/

 typedef struct tagMQCFH {
   MQLONG  Type;            /* Structure type */
   MQLONG  StrucLength;     /* Structure length */
   MQLONG  Version;         /* Structure version number */
   MQLONG  Command;         /* Command identifier */
   MQLONG  MsgSeqNumber;    /* Message sequence number */
   MQLONG  Control;         /* Control options */
   MQLONG  CompCode;        /* Completion code */
   MQLONG  Reason;          /* Reason code qualifying completion code */
   MQLONG  ParameterCount;  /* Count of parameter structures */
 } MQCFH;
 typedef MQCFH MQPOINTER PMQCFH;

 #define MQCFH_DEFAULT MQCFT_COMMAND,\
                       MQCFH_STRUC_LENGTH,\
                       MQCFH_VERSION_1,\
                       MQCMD_NONE,\
                       1L,\
                       MQCFC_LAST,\
                       MQCC_OK,\
                       MQRC_NONE,\
                       0L


 /*********************************************************************/
 /*  MQCFIL Structure -- PCF Integer-List Parameter                   */
 /*********************************************************************/

 typedef struct tagMQCFIL {
   MQLONG  Type;         /* Structure type */
   MQLONG  StrucLength;  /* Structure length */
   MQLONG  Parameter;    /* Parameter identifier */
   MQLONG  Count;        /* Count of parameter values */
   MQLONG  Values[1];    /* Parameter values -- first element */
 } MQCFIL;
 typedef MQCFIL MQPOINTER PMQCFIL;

 #define MQCFIL_DEFAULT MQCFT_INTEGER_LIST,\
                        MQCFIL_STRUC_LENGTH_FIXED,\
                        0L,\
                        0L,\
                        {0L}


 /*********************************************************************/
 /*  MQCFIN Structure -- PCF Integer Parameter                        */
 /*********************************************************************/

 typedef struct tagMQCFIN {
   MQLONG  Type;         /* Structure type */
   MQLONG  StrucLength;  /* Structure length */
   MQLONG  Parameter;    /* Parameter identifier */
   MQLONG  Value;        /* Parameter value */
 } MQCFIN;
 typedef MQCFIN MQPOINTER PMQCFIN;

 #define MQCFIN_DEFAULT MQCFT_INTEGER,\
                        MQCFIN_STRUC_LENGTH,\
                        0L,\
                        0L


 /*********************************************************************/
 /*  MQCFSL Structure -- PCF String-List Parameter                    */
 /*********************************************************************/

 typedef struct tagMQCFSL {
   MQLONG  Type;            /* Structure type */
   MQLONG  StrucLength;     /* Structure length */
   MQLONG  Parameter;       /* Parameter identifier */
   MQLONG  CodedCharSetId;  /* Coded character set identifier */
   MQLONG  Count;           /* Count of parameter values */
   MQLONG  StringLength;    /* Length of one string */
   MQCHAR  Strings[1];      /* String values -- first character */
 } MQCFSL;
 typedef MQCFSL MQPOINTER PMQCFSL;

 #define MQCFSL_DEFAULT MQCFT_STRING_LIST,\
                        MQCFSL_STRUC_LENGTH_FIXED,\
                        0L,\
                        MQCCSI_DEFAULT,\
                        0L,\
                        0L,\
                        {""}


 /*********************************************************************/
 /*  MQCFST Structure -- PCF String Parameter                         */
 /*********************************************************************/

 typedef struct tagMQCFST {
   MQLONG  Type;            /* Structure type */
   MQLONG  StrucLength;     /* Structure length */
   MQLONG  Parameter;       /* Parameter identifier */
   MQLONG  CodedCharSetId;  /* Coded character set identifier */
   MQLONG  StringLength;    /* Length of string */
   MQCHAR  String[1];       /* String value -- first character */
 } MQCFST;
 typedef MQCFST MQPOINTER PMQCFST;

 #define MQCFST_DEFAULT MQCFT_STRING,\
                        MQCFST_STRUC_LENGTH_FIXED,\
                        0L,\
                        MQCCSI_DEFAULT,\
                        0L,\
                        {""}


 #if defined(__cplusplus)
   }
 #endif

 /*********************************************************************/
 /*  End of CMQCFC                                                    */
 /*********************************************************************/
 #endif  /* End of header file */
