#ifndef _IMQCHL_HPP_
#define _IMQCHL_HPP_

//  Library:       MQSeries
//  Component:     IMQI (MQSeries C++ MQI)
//  Part:          IMQCHL.HPP
//
//  Description:   "ImqChannel" class declaration
//  <START_COPYRIGHT>
//  Statement:     Licensed Materials - Property of IBM
//
//                 84H2000, 5765-B73
//                 84H2001, 5639-B42
//                 84H2002, 5765-B74
//                 84H2003, 5765-B75
//                 84H2004, 5639-B43
//                 (C) Copyright IBM Corp. 1994, 2000
//
//                 U.S. Government Users Restricted Rights -
//                 use, duplication or disclosure restricted by
//                 GSA ADP Schedule Contract with IBM Corp.
//  <END_COPYRIGHT>

#include <imqstr.hpp> // ImqString

#define ImqChannel ImqChl

class ImqChannel : public ImqError {
  void * opdata ;
  ImqBoolean checkNames ( const size_t, const char * [ ] );
  ImqBoolean checkNames ( const size_t, const ImqString * [ ] );
  ImqBoolean getItems ( const size_t, ImqString * [ ],
                        const char *, const size_t, const size_t );
  ImqBoolean setData ( const MQLONG, const size_t, const char * [ ], MQPTR & );
  ImqBoolean setData ( const MQLONG, const size_t, const ImqString * [ ],
                       MQPTR & );
  ImqBoolean setNames ( const size_t, const char * [ ], MQPTR &, MQPTR & );
  ImqBoolean setNames ( const size_t, const ImqString * [ ], MQPTR &,
                        MQPTR & );
  void varyStorage ( MQLONG &, const size_t, MQPTR &, MQPTR & );
protected :
  friend class ImqMgr ;
  PMQCD MQCD ( ) const ;
public :
  // New methods:
  ImqChannel ( );
  ImqChannel ( const ImqChannel & );
  virtual ~ ImqChannel ( );
  void operator = ( const ImqChannel & );
  ImqString channelName ( ) const ;
  ImqString connectionName ( ) const ;
  MQLONG heartBeatInterval ( ) const ;
  MQLONG maximumMessageLength ( ) const ;
  ImqString modeName ( ) const ;
  ImqString password ( ) const ;
  size_t receiveExitCount ( ) const ;
  ImqString receiveExitName ( );
  ImqBoolean receiveExitNames ( const size_t, ImqString * [ ] );
  ImqString receiveUserData ( );
  ImqBoolean receiveUserData ( const size_t, ImqString * [ ] );
  ImqString securityExitName ( ) const ;
  ImqString securityUserData ( ) const ;
  size_t sendExitCount ( ) const ;
  ImqString sendExitName ( );
  ImqBoolean sendExitNames ( const size_t, ImqString * [ ] );
  ImqString sendUserData ( );
  ImqBoolean sendUserData ( const size_t, ImqString * [ ] );
  ImqBoolean setChannelName ( const char * = 0 );
  ImqBoolean setConnectionName ( const char * = 0 );
  ImqBoolean setHeartBeatInterval ( const MQLONG = 300L );
  ImqBoolean setMaximumMessageLength ( const MQLONG = 4194304L );
  ImqBoolean setModeName ( const char * = 0 );
  ImqBoolean setPassword ( const char * = 0 );
  ImqBoolean setReceiveExitName ( const char * = 0 );
  ImqBoolean setReceiveExitNames ( const size_t, const char * [ ] );
  ImqBoolean setReceiveExitNames ( const size_t, const ImqString * [ ] );
  ImqBoolean setReceiveUserData ( const char * = 0 );
  ImqBoolean setReceiveUserData ( const size_t, const char * [ ] );
  ImqBoolean setReceiveUserData ( const size_t, const ImqString * [ ] );
  ImqBoolean setSecurityExitName ( const char * = 0 );
  ImqBoolean setSecurityUserData ( const char * = 0 );
  ImqBoolean setSendExitName ( const char * = 0 );
  ImqBoolean setSendExitNames ( const size_t, const char * [ ] );
  ImqBoolean setSendExitNames ( const size_t, const ImqString * [ ] );
  ImqBoolean setSendUserData ( const char * = 0 );
  ImqBoolean setSendUserData ( const size_t, const char * [ ] );
  ImqBoolean setSendUserData ( const size_t, const ImqString * [ ] );
  ImqBoolean setTransactionProgramName ( const char * = 0 );
  ImqBoolean setTransportType ( const MQLONG = MQXPT_LU62 );
  ImqBoolean setUserId ( const char * = 0 );
  ImqString transactionProgramName ( ) const ;
  MQLONG transportType ( ) const ;
  ImqString userId ( ) const ;
} ;

#endif
