#ifndef _IMQERR_HPP_
#define _IMQERR_HPP_

//  Library:       MQSeries
//  Component:     IMQI (MQSeries C++ MQI)
//  Part:          IMQERR.HPP
//
//  Description:   "ImqError" class declaration
//  <START_COPYRIGHT>
//  Statement:     Licensed Materials - Property of IBM
//
//                 04L1773, 5765-B73
//                 04L1788, 5765-B74
//                 04L1816, 5765-B75
//                 04L1802, 5639-B42
//                 04L1830, 5639-B43
//                 (C) Copyright IBM Corp. 1994, 2000
//
//                 U.S. Government Users Restricted Rights -
//                 use, duplication or disclosure restricted by
//                 GSA ADP Schedule Contract with IBM Corp.
//  <END_COPYRIGHT>

extern "C" {
#include <cmqc.h>
#include <cmqxc.h>
#include <imqtype.h>
#include <string.h>
}

#define ImqError ImqErr

class ImqObj ;
class ImqPmo ;
class ImqError {
  MQLONG olCompletionCode ;
  MQLONG olReasonCode ;
protected :
  friend class ImqObj ;
  friend class ImqPmo ;
  friend class ImqStr ;
  // New methods:
  ImqBoolean checkReadPointer ( const void *, const size_t );
  ImqBoolean checkWritePointer ( const void *, const size_t );
  void setCompletionCode ( const MQLONG lCode = 0 )
    { olCompletionCode = lCode ; }
  void setReasonCode ( const MQLONG lCode = 0 ) { olReasonCode = lCode ; }
public :
  // New methods:
  ImqError ( );
  ImqError ( const ImqError & );
  virtual ~ ImqError ( );
  void operator = ( const ImqError & );
  void clearErrorCodes ( );
  MQLONG completionCode ( ) const { return olCompletionCode ; }
  MQLONG reasonCode ( ) const { return olReasonCode ; }
#if defined( __WIN__ ) && defined( __32__ ) && defined( _MSC_VER )
#if ( _MSC_VER >= 1100 )
  __declspec( dllexport ) void * operator new [ ]( size_t );
  __declspec( dllexport ) void operator delete [ ]( void * );
#endif
  __declspec( dllexport ) void * operator new ( size_t );
  __declspec( dllexport ) void operator delete ( void * );
#endif
} ;

#endif // _IMQERR_HPP_

