#ifndef _IMQPRO_HPP_
#define _IMQPRO_HPP_

//  Library:       MQSeries
//  Component:     IMQI (MQSeries C++ MQI)
//  Part:          IMQPRO.HPP
//
//  Description:   "ImqProcess" class declaration
//  <START_COPYRIGHT>
//  Statement:     Licensed Materials - Property of IBM                          
//                                                               
//                 04L1773, 5765-B73
//                 04L1788, 5765-B74
//                 04L1816, 5765-B75
//                 04L1802, 5639-B42
//                 04L1830, 5639-B43
//                 (C) Copyright IBM Corp. 1994, 1999                      
//
//                 U.S. Government Users Restricted Rights -
//                 use, duplication or disclosure restricted by
//                 GSA ADP Schedule Contract with IBM Corp.
//  <END_COPYRIGHT>

#include <imqobj.hpp> // ImqObject

#define ImqProcess ImqPro

class ImqProcess : public ImqObject {
public :
  // Overloaded "ImqObject" methods:
  virtual ImqBoolean description ( ImqString & );
  virtual ImqBoolean name ( ImqString & );
  // Directed "ImqObject" methods:
  ImqString description ( ) { return ImqObject::description( ); }
  ImqString name ( ) { return ImqObject::name( ); }
  // New methods:
  ImqProcess ( );
  ImqProcess ( const char * );
  ImqProcess ( const ImqProcess & );
  virtual ~ ImqProcess ( );
  void operator = ( const ImqProcess & );
  ImqBoolean applicationId ( ImqString & );
  ImqString applicationId ( );
  ImqBoolean applicationType ( MQLONG & );
  MQLONG applicationType ( );
  ImqBoolean environmentData ( ImqString & );
  ImqString environmentData ( );
  ImqBoolean userData ( ImqString & );
  ImqString userData ( );
} ;

#endif
