#ifndef _IMQTYPE_H_
#define _IMQTYPE_H_

/*********************************************************************/
/*                                                                   */
/* Library:       MQSeries                                           */
/* Component:     IMQB (MQSeries C++ support)                        */
/* Part:          IMQTYPE.H                                          */
/*                                                                   */
/* Description:   This part identifies the compilation environment   */
/*                and sets manifest constants accordingly. Data      */
/*                types for MQSeries C++ are defined.                */
/* <START_COPYRIGHT>                                                 */
/*  Statement:     Licensed Materials - Property of IBM              */
/*                                                                   */
/*                 04L1773, 5765-B73                                 */
/*                 04L1788, 5765-B74                                 */
/*                 04L1816, 5765-B75                                 */
/*                 04L1802, 5639-B42                                 */
/*                 04L1830, 5639-B43                                 */
/*                 (C) Copyright IBM Corp. 1994, 2000                */
/* <END_COPYRIGHT>                                                   */
/*********************************************************************/

#if defined( _MSC_VER ) || defined( __WINDOWS__ )

/* Windows family */
#define __WIN__ 1

#if defined( _MSDOS )

/* Visual C++ 1.5 */
#define __16__ 1
#define _CPP_VER 300

#else

/* Visual C++ 2 or better, VisualAge C++ 3.5 */
#define __32__ 1
#define _CPP_VER 300

#endif

#elif defined( __OS2__ )

/* IBM OS/2 */
#define __32__ 1
#define _CPP_VER 300

#elif defined( _AIX )

/* IBM AIX */
#define __AIX__ 1
#define __UNIX__ 1
#define __32__ 1
#define _CPP_VER 300

#elif defined( __MVS__ )

/* IBM MVS/ESA */
#define __32__ 1
#define _CPP_VER 300

#elif defined( __OS400__ )

/* IBM AS/400 */
#define __64__ 1
#define _CPP_VER 300

#elif defined( sun )

/* SUN Solaris */
#define __UNIX__ 1
#define __32__ 1
#define _CPP_VER 210

#elif defined( hpux )

#define __UNIX__ 1
#define __32__ 1
#define _CPP_VER 210

#else

/* Other OS. Defaults assumed. */
#define __UNIX__ 1
#define __32__ 1
#define _CPP_VER 210

#endif

#if ! defined( TRUE )
#define TRUE 1
#endif

#if ! defined( FALSE )
#define FALSE 0
#endif

#if ! defined( _IMQ_VER )
#define _IMQ_VER 230
#endif

#if ! defined( MQCNO_VERSION_3 )
#define MQCNO_VERSION_3 3L
#endif

typedef unsigned char ImqBoolean ;

#ifndef MQRC_REOPEN_EXCL_INPUT_ERROR
#define MQRC_REOPEN_EXCL_INPUT_ERROR   6100L
#define MQRC_REOPEN_INQUIRE_ERROR      6101L
#define MQRC_REOPEN_SAVED_CONTEXT_ERR  6102L
#define MQRC_REOPEN_TEMPORARY_Q_ERROR  6103L
#define MQRC_ATTRIBUTE_LOCKED          6104L
#define MQRC_CURSOR_NOT_VALID          6105L
#define MQRC_ENCODING_ERROR            6106L
#define MQRC_STRUC_ID_ERROR            6107L
#define MQRC_NULL_POINTER              6108L
#define MQRC_NO_CONNECTION_REFERENCE   6109L
#define MQRC_NO_BUFFER                 6110L
#define MQRC_BINARY_DATA_LENGTH_ERROR  6111L
#define MQRC_BUFFER_NOT_AUTOMATIC      6112L
#define MQRC_INSUFFICIENT_BUFFER       6113L
#define MQRC_INSUFFICIENT_DATA         6114L
#define MQRC_DATA_TRUNCATED            6115L
#define MQRC_ZERO_LENGTH               6116L
#define MQRC_NEGATIVE_LENGTH           6117L
#define MQRC_NEGATIVE_OFFSET           6118L
#define MQRC_INCONSISTENT_FORMAT       6119L
#define MQRC_INCONSISTENT_OBJECT_STATE 6120L
#define MQRC_CONTEXT_OBJECT_NOT_VALID  6121L
#define MQRC_CONTEXT_OPEN_ERROR        6122L
#define MQRC_STRUC_LENGTH_ERROR        6123L
#define MQRC_NOT_CONNECTED             6124L
#define MQRC_NOT_OPEN                  6125L
#define MQRC_DISTRIBUTION_LIST_EMPTY   6126L
#define MQRC_INCONSISTENT_OPEN_OPTIONS 6127L
#define MQRC_WRONG_VERSION             6128L
#define MQRC_REFERENCE_ERROR           6129L
#endif

#endif
