/**********************************************************************/
/*                                                                    */
/* Module Name: AMQODTHA.H                                            */
/*                                                                    */
/* Description: Trace constants for MQSeries DLQ handler.             */
/* <START_COPYRIGHT>                                                  */
/*  Statement:     Licensed Materials - Property of IBM               */                      
/*                                                                    */      
/*                 04L1773, 5765-B73                                  */            
/*                 04L1802, 5639-B42                                  */            
/*                 04L1788, 5765-B74                                  */            
/*                 04L1816, 5765-B75                                  */            
/*                 04L1830, 5639-B43                                  */            
/*                 (C) Copyright IBM Corp. 1994, 1999                 */
/* <END_COPYRIGHT>                                                    */
/* Function:                                                          */
/* Trace constants used by MQSeries DLQ handler.                      */
/*                                                                    */
/**********************************************************************/
#if !defined AMQODTHA_H || defined ODQ_FUNCTION_NAMES
#define AMQODTHA_H

#ifdef  ODQ_FUNCTION_NAMES
#undef odq_function_name
#define odq_function_name(name) \
 #name 
#else 
typedef enum
{
#undef odq_function_name
#define odq_function_name(name) \
 odqt##name 
#endif
  odq_function_name(main),
  odq_function_name(odqConnectQmgr),
  odq_function_name(odqDisconnectQmgr),
  odq_function_name(odqInquireQMAttrs),

  odq_function_name(odqProcessQueue),
  odq_function_name(odqSyncpoint),
  odq_function_name(odqStartBrowse),
  odq_function_name(odqEndBrowse),
  odq_function_name(odqGetNext ),
  odq_function_name(odqProcessMessage),

  odq_function_name(odqyyparse),
  odq_function_name(odqProcessStdin),
  odq_function_name(odqPrepareTemplate),
  odq_function_name(odqAddParm),
  odq_function_name(odqUseDefault),
  odq_function_name(odqAddLine),

  odq_function_name(odqMatchMessage),
  odq_function_name(odqMatchLine),
  odq_function_name(odqMatchString),
  odq_function_name(odqMatchInteger),

  odq_function_name(odqPreInitialize),
  odq_function_name(odqInitialize),
  odq_function_name(odqFFDC),
  odq_function_name(odqGetMem),
  odq_function_name(odqFreeMem),
  odq_function_name(odqMQCONN),

  odq_function_name(odqInquireRetryCount),
  odq_function_name(odqAddMsg),
  odq_function_name(odqDeleteMsg),

  odq_function_name(odqStrDup),
  odq_function_name(odqQStrDup),
  odq_function_name(odqAtoi),
  odq_function_name(odqSymbtoi),
  odq_function_name(odqInitialiseRetryCount), 
  odq_function_name(LastFunc)

/**********************************************************************/
/* LastFunc must be defined as the last entry in order for            */
/* xtrGetFunction to work correctly since it checks that the number   */
/* of the function is within the valid range.                         */
/**********************************************************************/

#ifdef  ODQ_FUNCTION_NAMES
#else 
} odqTraceId;
#endif

#endif

