/* @(#) samples/c/xatm/oraswit0.c, tranmgr, p520, p520-CSD07G  1.6.1.1 00/11/15 13:28:09 */
/******************************************************************************/
/*                                                                            */
/* Module name: oraswit.c                                                     */
/*                                                                            */
/* Description: MQSeries XA switch program for Oracle                         */
/*                                                                            */
/* Statement:   Licensed Materials - Property of IBM                          */
/*              04L1773, 5765-B73                                             */
/*              04L1788, 5765-B74                                             */
/*              04L1816, 5765-B75                                             */
/*              (C) Copyright IBM Corp. 1998                                  */
/*                                                                            */
/******************************************************************************/

/******************************************************************************/
/* Includes                                                                   */
/******************************************************************************/

#include <cmqc.h>                                /* MQ header                 */
#include "xa.h"                                  /* MQ supplied XA header     */

/******************************************************************************/
/* External data declarations                                                 */
/******************************************************************************/

extern struct xa_switch_t xaosw;

/******************************************************************************/
/*                                                                            */
/* Function name:  MQStart                                                    */
/*                                                                            */
/* Description: The queue manager calls this function to access the XA switch */
/*              of Oracle                                                     */
/*                                                                            */
/******************************************************************************/
/*                                                                            */
/* Input Parameters:  None                                                    */
/*                                                                            */
/* Output Parameters: None                                                    */
/*                                                                            */
/* Returns:           Pointer to Oracle XA switch                             */
/*                                                                            */
/******************************************************************************/
struct xa_switch_t * MQENTRY MQStart(void)
{
   return(&xaosw);
}

/******************************************************************************/
/* End of oraswit.c                                                           */
/******************************************************************************/
