#
# Name:          XASWIT.MAK
#
# Description:   Linux makefile for DB2 and Oracle XA switch files
#
# Statement:     Licensed Materials - Property of IBM
#                04L1816, 5765-B75
#                (C) Copyright IBM Corp. 1998
#
#
# To make the DB2 XA switch load file, run the command:-
#                make -f xaswit.mak db2swit
#
# To make the Oracle XA switch load file, run the command:-
#                make -f xaswit.mak oraswit
#
# Note: If your database libraries are in a different directory
#       to the one listed in the xxxLIBPATH statement, you will
#       need to alter or add that directory to the statement.

CC=gcc

#--------------------------------------------------------------------
# DB2 XA switch file
#--------------------------------------------------------------------
# If db2 libraries are installed in a directory different to that specified
# below, then update the line below, or use the db2ln utility and remove
# DB2LIBPATH from the DB2LINKFLAGS
DB2LIBS=-ldb2
DB2LIBPATH=/usr/IBMdb2/V6.1/lib

# Uncomment the following line to use IBM DB2 V7.1
# DB2LIBPATH=/usr/IBMdb2/V7.1/lib

DB2LINKFLAGS=-L$(DB2LIBPATH) $(DB2LIBS) -e MQStart -shared -Wl,-rpath=$(DB2LIBPATH)

db2swit:
	$(CC) $(DB2LINKFLAGS) -o $@ db2swit.c

#--------------------------------------------------------------------
# Oracle XA switch file
#--------------------------------------------------------------------
ORALIBS=-lclntsh
ORALIBPATH=$(ORACLE_HOME)/lib

ORALINKFLAGS=-L$(ORALIBPATH) $(ORALIBS) -e MQStart -shared -Wl,-rpath=$(ORALIBPATH)

oraswit:
	$(CC) $(ORALINKFLAGS) -o $@ oraswit.c

